'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('./index.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Chart = function (_Component) {
  (0, _inherits3.default)(Chart, _Component);

  function Chart() {
    (0, _classCallCheck3.default)(this, Chart);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Chart.__proto__ || (0, _getPrototypeOf2.default)(Chart)).call(this));

    _this.handleResize = _this.handleResize.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Chart, [{
    key: 'renderChart',
    value: function renderChart(props) {
      this.chart = new this.props.type((0, _extends3.default)({
        container: this.container
      }, props));
    }
  }, {
    key: 'handleSuccess',
    value: function handleSuccess(data) {
      this.renderChart((0, _extends3.default)({}, this.props, {
        data: data
      }));
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (this.props.data !== nextProps.data) {
        this.renderChart(nextProps);
        return false;
      }
      return true;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.container = _reactDom2.default.findDOMNode(this);
      (0, _invariant2.default)(this.container.clientWidth, 'Chart container `width` is `0`');
      if (this.props.data) {
        this.renderChart(this.props);
      }
      // Enable responsive
      window.addEventListener('resize', this.handleResize);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.handleResize);
    }
  }, {
    key: 'handleResize',
    value: function handleResize() {
      this.chart.resize && this.chart.resize();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          url = _props.url,
          type = _props.type,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'url', 'type']);

      return _react2.default.createElement(_Fetch2.default, (0, _extends3.default)({
        ref: 'container',
        className: (0, _classnames2.default)('bfd-chart', className),
        url: url,
        onSuccess: this.handleSuccess.bind(this)
      }, other));
    }
  }]);
  return Chart;
}(_react.Component);

Chart.propTypes = {
  url: _react.PropTypes.string,
  data: _react.PropTypes.array,
  customProp: function customProp(_ref) {
    var url = _ref.url,
        data = _ref.data;

    if (!url && !data) {
      return new Error('No `url` or `data` property.');
    }
    if (url && data) {
      return new Error('`url` and `data` can\'t exist at the same time.');
    }
  }
};

exports.default = Chart;