'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactUpdate = require('react-update');

var _reactUpdate2 = _interopRequireDefault(_reactUpdate);

var _Checkbox = require('../Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _shouldComponentUpdate = require('../../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var CheckboxGroup = function (_Component) {
  (0, _inherits3.default)(CheckboxGroup, _Component);

  function CheckboxGroup(props) {
    (0, _classCallCheck3.default)(this, CheckboxGroup);

    var _this = (0, _possibleConstructorReturn3.default)(this, (CheckboxGroup.__proto__ || (0, _getPrototypeOf2.default)(CheckboxGroup)).call(this));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.update = _reactUpdate2.default.bind(_this);
    _this.state = {
      selects: props.selects || props.defaultSelects || []
    };
    return _this;
  }

  (0, _createClass3.default)(CheckboxGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      nextProps.selects && this.update('set', 'selects', nextProps.selects);
    }
  }, {
    key: 'change',
    value: function change() {
      var selects = this.update.apply(this, arguments);
      this.props.onChange && this.props.onChange(selects);
    }
  }, {
    key: 'addSelect',
    value: function addSelect(value) {
      this.change('push', 'selects', value);
    }
  }, {
    key: 'removeSelect',
    value: function removeSelect(value) {
      this.change('splice', 'selects', this.state.selects.indexOf(value));
    }
  }, {
    key: 'toggleAll',
    value: function toggleAll(e) {
      var selects = e.target.checked ? this.state.selects.concat(this.unSelects) : [];
      this.change('set', { selects: selects });
    }
  }, {
    key: 'handleCheckboxChange',
    value: function handleCheckboxChange(value, e) {
      this[(e.target.checked ? 'add' : 'remove') + 'Select'](value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          defaultSelects = _props.defaultSelects,
          onChange = _props.onChange,
          values = _props.values,
          block = _props.block,
          toggleable = _props.toggleable,
          toggleAllContent = _props.toggleAllContent,
          other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'defaultSelects', 'onChange', 'values', 'block', 'toggleable', 'toggleAllContent']);
      var selects = this.state.selects;


      var unSelects = [];
      delete other.selects;

      var checkboxes = void 0;
      if (values) {
        checkboxes = values.map(function (value, i) {
          var checked = selects.indexOf(value) !== -1;
          checked || unSelects.push(value);
          return _react2.default.createElement(
            _Checkbox2.default,
            {
              key: i,
              value: value,
              checked: checked,
              onChange: _this2.handleCheckboxChange.bind(_this2, value),
              block: block
            },
            value
          );
        });
      } else {
        checkboxes = _react2.default.Children.map(children, function (Checkbox, i) {
          if (!Checkbox) return;
          var props = Checkbox.props;
          var value = props.value;

          var checked = selects.indexOf(value) !== -1;

          if (!checked && !props.disabled) {
            unSelects.push(value);
          }

          return _react2.default.cloneElement(Checkbox, {
            key: i,
            checked: checked,
            block: props.block || block,
            onChange: _this2.handleCheckboxChange.bind(_this2, value)
          });
        });
      }

      this.unSelects = unSelects;

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-checkbox-group', className) }, other),
        toggleable && checkboxes && checkboxes.length > 1 && _react2.default.createElement(
          _Checkbox2.default,
          {
            block: block,
            checked: unSelects.length === 0,
            indeterminate: unSelects.length > 0 && unSelects.length < checkboxes.length,
            onChange: this.toggleAll.bind(this)
          },
          toggleAllContent
        ),
        checkboxes
      );
    }
  }]);
  return CheckboxGroup;
}(_react.Component);

CheckboxGroup.defaultProps = {
  toggleAllContent: '全选'
};

CheckboxGroup.propTypes = {

  // 选中的值
  selects: _react.PropTypes.array,

  // 初始选中的值（不可控）
  defaultSelects: _react.PropTypes.array,

  // 更改选择后的回调，参数为选中的值
  onChange: _react.PropTypes.func,

  // 针对 value 和 label 相同时快速创建复选框组，无需再调用 Checkbox
  values: _react.PropTypes.array,

  // 是否垂直排列
  block: _react.PropTypes.bool,

  // 是否开启全选功能
  toggleable: _react.PropTypes.bool,

  // 全选切换复选框显示的文字
  toggleAllContent: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var selects = _ref.selects,
        onChange = _ref.onChange;

    if (selects && !onChange) {
      return new Error('You provided a `selects` prop without an `onChange` handler');
    }
  }
};

exports.default = CheckboxGroup;