'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _Paging = require('../Paging');

var _Paging2 = _interopRequireDefault(_Paging);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Checkbox = require('../Checkbox');

var _Rows = require('./Rows');

var _Rows2 = _interopRequireDefault(_Rows);

require('./main.css');

require('../table.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var DataTable = function (_Component) {
  (0, _inherits3.default)(DataTable, _Component);

  function DataTable(props) {
    (0, _classCallCheck3.default)(this, DataTable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DataTable.__proto__ || (0, _getPrototypeOf2.default)(DataTable)).call(this));

    _this.items = [];
    _this.selectedRows = [];
    _this.state = {
      order: '',
      url: props.url || '',
      isSelectAll: false,
      items: {
        totalList: [],
        totalPageNum: 0,
        refresh: false,
        currentPage: 1
      },
      currentPage: props.currentPage || 1
    };
    return _this;
  }

  (0, _createClass3.default)(DataTable, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (this.props.data) {
        this.setState({
          items: {
            totalList: this.props.data.totalList || [],
            totalPageNum: this.props.data.totalPageNum || 0,
            refresh: false,
            currentPage: this.props.data.currentPage || 1
          }
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.data) {
        this.setState({
          items: nextProps.data,
          isSelectAll: false
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var self = this;
      var url = this.props.url || '';
      var _props = this.props,
          className = _props.className,
          column = _props.column,
          howRow = _props.howRow,
          data = _props.data,
          showPage = _props.showPage,
          onPageChange = _props.onPageChange,
          onCheckboxSelect = _props.onCheckboxSelect,
          onRowClick = _props.onRowClick,
          onOrder = _props.onOrder,
          noDataContent = _props.noDataContent,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'column', 'howRow', 'data', 'showPage', 'onPageChange', 'onCheckboxSelect', 'onRowClick', 'onOrder', 'noDataContent']);

      var currentPage = parseInt(this.state.currentPage),

      // 新增自动分页功能
      pageSize = parseInt(this.props.howRow);

      // 如果是传入url查询数据就附带参数查询
      if (url && url !== '') {
        if (url.indexOf('?') < 0) {
          if (this.props.showPage == 'true') {
            url += '?pageSize=' + pageSize + '&currentPage=' + this.state.currentPage;
          }
        }
        if (url.indexOf('pageSize') < 0 && url.indexOf('currentPage') < 0 && url.indexOf('?') > -1) {
          url += '&pageSize=' + pageSize + '&currentPage=' + this.state.currentPage;
        }
      }

      var checkboxTh = this.props.onCheckboxSelect ? _react2.default.createElement(
        'th',
        null,
        _react2.default.createElement(_Checkbox.Checkbox, { checked: this.state.isSelectAll, onChange: this.handleCheckboxAllChange.bind(this) })
      ) : null;

      return _react2.default.createElement(
        _Fetch2.default,
        { defaultHeight: 100, url: url, onSuccess: this.handleSuccess.bind(this) },
        _react2.default.createElement(
          'table',
          (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-datatable', 'bfd-table', className) }, other),
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              checkboxTh,
              column.map(function (head, i) {
                var style = {};
                var orderClassName = '';
                if (head.width) {
                  style.width = head.width;
                }
                if (head.hide === true) {
                  style.display = 'none';
                }
                if (head['order'] === true) {
                  orderClassName = 'bfd-datatable--sorting';
                } else if (head['order'] === 'asc') {
                  orderClassName = 'bfd-datatable--sorting_asc-default';
                } else if (head['order'] === 'desc') {
                  orderClassName = 'bfd-datatable--sorting_desc-default';
                }

                return _react2.default.createElement(
                  'th',
                  {
                    key: head['title'],
                    ref: i,
                    style: style,
                    onClick: self.orderClick.bind(self, head, i),
                    className: orderClassName },
                  head['title']
                );
              })
            )
          ),
          _react2.default.createElement(_Rows2.default, {
            rows: this.state.items.totalList,
            onRowClick: this.handleRowClick.bind(this),
            onSelect: this.handleCheckboxChange.bind(this),
            onCheckboxSelect: this.props.onCheckboxSelect,
            onCheckboxSelectAll: this.setCheckboxAll.bind(this),
            column: this.props.column,
            currentPage: this.state.items.currentPage || currentPage,
            pageSize: pageSize,
            noDataContent: noDataContent
          })
        ),
        this.state.items.totalList.length > 0 ? this.props.showPage == 'true' ? _react2.default.createElement(_Paging2.default, {
          hideGo: this.props.hideGo,
          currentPage: this.state.items.currentPage,
          totalPageNum: this.state.items.totalPageNum,
          pageSize: this.props.howRow,
          onPageChange: this.onPageChange.bind(this) }) : '' : ''
      );
    }
  }, {
    key: 'onPageChange',
    value: function onPageChange(page) {
      if (this.props.onPageChange) {
        this.props.onPageChange(page);
      }
      this.setState({
        currentPage: page
      });
    }
  }, {
    key: 'orderClick',
    value: function orderClick(column, i) {
      if (column.order) {
        var orderEl = this.refs[i];
        var orderElAttr = this.getOrderAttribute(i);
        if (orderElAttr == null || !orderElAttr) {
          if (column.order === true) {
            orderEl.className = 'bfd-datatable--sorting_asc';
            orderEl.setAttribute('order', 'asc');
            this.setState({
              order: '&key=' + column['key'] + '&sort=asc'
            });
            this.props.onOrder && this.props.onOrder(column['key'], 'asc');
          } else if (column.order === 'asc') {
            orderEl.className = 'bfd-datatable--sorting_asc';
            orderEl.setAttribute('order', 'asc');
            this.setState({
              order: '&key=' + column['key'] + '&sort=asc'
            });
            this.props.onOrder && this.props.onOrder(column['key'], 'asc');
          } else if (column.order === 'desc') {
            orderEl.className = 'bfd-datatable--sorting_desc';
            orderEl.setAttribute('order', 'desc');
            this.setState({
              order: '&key=' + column['key'] + '&sort=desc'
            });
            this.props.onOrder && this.props.onOrder(column['key'], 'desc');
          }
          return;
        }
        if (orderElAttr == 'asc') {
          if (column.order === true) {
            this.refs[i].className = 'bfd-datatable--sorting_desc';
            this.refs[i].setAttribute('order', 'desc');
            this.setState({
              order: '&key=' + column['key'] + '&sort=desc'
            });
            this.props.onOrder && this.props.onOrder(column['key'], 'desc');
          } else if (column.order === 'asc') {
            this.refs[i].className = 'bfd-datatable--sorting_asc-default';
            this.refs[i].setAttribute('order', '');
            this.setState({
              order: '&key=' + column['key']
            });
            this.props.onOrder && this.props.onOrder(column['key'], '');
          }
          return;
        }
        if (orderElAttr == 'desc') {
          if (column.order === true) {
            this.refs[i].className = 'bfd-datatable--sorting_asc';
            this.refs[i].setAttribute('order', 'asc');
            this.setState({
              order: '&key=' + column['key'] + '&sort=asc'
            });
            this.props.onOrder && this.props.onOrder(column['key'], 'asc');
          } else if (column.order === 'desc') {
            this.refs[i].className = 'bfd-datatable--sorting_desc-default';
            this.refs[i].setAttribute('order', '');
            this.setState({
              order: '&key=' + column['key']
            });
            this.props.onOrder && this.props.onOrder(column['key'], '');
          }
          return;
        }
      }
    }
  }, {
    key: 'getOrderAttribute',
    value: function getOrderAttribute(refName) {
      return this.refs[refName].getAttribute('order');
    }
  }, {
    key: 'handleSuccess',
    value: function handleSuccess(data) {
      this.setState({
        items: data,
        isSelectAll: false
      });
    }
  }, {
    key: 'refresh',
    value: function refresh() {
      this.setState({
        refresh: true
      });
    }
  }, {
    key: 'handleCheckboxAllChange',
    value: function handleCheckboxAllChange() {
      var _this2 = this;

      var isAll = !this.state.isSelectAll;
      var rows = this.state.items.totalList;
      var key = this.getPrimaryKey(this.props.column);
      rows.map(function (item) {
        if (item.isSelect !== isAll && !item.disabled) {
          item.isSelect = isAll;
        }
        _this2.setCheckboxAll(isAll);
        var addFlag = true;

        for (var i = 0, len = _this2.selectedRows.length; i < len; i++) {
          var row = _this2.selectedRows[i];
          if (key && row[key] == item[key]) {
            addFlag = false;
            if (!isAll) {
              _this2.selectedRows.splice(i, 1);
            }
            break;
          }
        }
        if (key && addFlag && isAll) {
          _this2.selectedRows.push(item);
        }
      });

      var selectAllFn = this.props.onCheckboxSelect;
      selectAllFn && selectAllFn(isAll ? rows : [], this.selectedRows);
    }
  }, {
    key: 'setCheckboxAll',
    value: function setCheckboxAll(isAll) {
      this.setState({
        isSelectAll: isAll
      });
    }
  }, {
    key: 'handleCheckboxChange',
    value: function handleCheckboxChange(checked, row, rows, selectedRows) {
      var selectFn = this.props.onCheckboxSelect;
      this.selectedRows = selectedRows;
      selectFn && selectFn(rows, selectedRows);
      if (!checked) {
        this.setState({
          isSelectAll: false
        });
      }
      if (rows.length == this.state.items.totalList.length) {
        this.setState({
          isSelectAll: true
        });
      }
    }
  }, {
    key: 'handleRowClick',
    value: function handleRowClick() {
      var _props2;

      this.props.onRowClick && (_props2 = this.props).onRowClick.apply(_props2, arguments);
    }
  }, {
    key: 'getPrimaryKey',
    value: function getPrimaryKey(column) {
      var key = void 0;
      column.map(function (item) {
        if (item.primary === true) {
          key = item.key;
        }
      });
      return key;
    }
  }]);
  return DataTable;
}(_react.Component);

DataTable.defaultProps = {
  noDataContent: '无数据'
};

DataTable.propTypes = {

  // 要请求数据的服务端地址。
  url: _react.PropTypes.string,

  /**
   * 数据表格表头列名称，目前支持的配置项如下：
   * ```js
   * [{
   *   title: '姓名', // 列头显示的文本
   *   key: 'name', // 映射数据字段名称
   *   primary: true, //主键标识，默认为false
   *   width: '20%', // 列宽度设置
   *   order: true, // 排序设置,true: 支持升序和降序，asc: 只支持升序，desc: 只支持降序，与onOrder事件并用
   *   // 列渲染的回调函数，可以自定义返回显示数据，text为当前行当前列值，item为当前行数据, index为当前行序列
   *   render: (text, item, index) => {
   *     return item.country + '/' + item.area
   *   }
   * },
   * ...
   * ]
   * ```
   */
  column: _react.PropTypes.array.isRequired,

  // 每页需要显示的条数
  howRow: _react.PropTypes.number,

  // DataTable显示数据，选填，url和data属性二者之间必须有一个，不必同时出现。data支持一次性查询多条数据传入data属性中，不需要点击一次分页再发送一次ajax请求，此功能根据业务需求使用！
  data: _react.PropTypes.object,

  // 是否显示分页，true为显示，false为不显示,如果showPage设置为false，就要同时取消howRow每页显示多少条的设置
  showPage: _react.PropTypes.string,

  // 点击分页时回调函数，此回调方法是点击切换分页时触发，可以在此方法体内发送Ajax请求数据，来替代组件的url属性！注【如果组件加入此属性方法，则不可以再传入url属性】
  onPageChange: _react.PropTypes.func,

  // 复选框点击事件，返回被选中的行记录（本页），如果在column中设置主键，此函数第二个参数为已选的行记录（跨页）
  onCheckboxSelect: _react.PropTypes.func,

  // 行点击事件，function(rowData, index, event)
  onRowClick: _react.PropTypes.func,

  // 列名称点击排序事件，返回列名称和排序状态
  onOrder: _react.PropTypes.func,

  // 隐藏页面跳转功能
  hideGo: _react.PropTypes.bool,

  // 无数据时显示的内容，默认`无数据`
  noDataContent: _react.PropTypes.string,

  customProp: function customProp(_ref) {
    var data = _ref.data,
        url = _ref.url;

    if (data && url) {
      return new Error('data属性和url属性不能同时使用！');
    }
  }
};

exports.default = DataTable;