'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _propsToState = require('../_shared/propsToState');

var _propsToState2 = _interopRequireDefault(_propsToState);

var _dataFilter = require('../_shared/dataFilter');

var _dataFilter2 = _interopRequireDefault(_dataFilter);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _Paging = require('../Paging');

var _Paging2 = _interopRequireDefault(_Paging);

require('../table.css');

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DataTable = function (_Component) {
  (0, _inherits3.default)(DataTable, _Component);

  function DataTable(props) {
    (0, _classCallCheck3.default)(this, DataTable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DataTable.__proto__ || (0, _getPrototypeOf2.default)(DataTable)).call(this));

    _this.state = {
      currentPage: props.currentPage || 1,
      totalCounts: props.totalCounts,
      data: props.data || [],
      sortKey: props.sortKey,
      sortType: props.sortType || 'desc'
    };
    return _this;
  }

  (0, _createClass3.default)(DataTable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState((0, _propsToState2.default)(nextProps, ['data', 'totalCounts', 'currentPage', 'sortKey', 'sortType']));
    }
  }, {
    key: 'handleSort',
    value: function handleSort(nextSortKey) {
      var _state = this.state,
          sortKey = _state.sortKey,
          sortType = _state.sortType;

      var nextSortType = void 0;
      if (sortKey === nextSortKey) {
        nextSortType = sortType === 'desc' ? 'asc' : 'desc';
      } else {
        nextSortType = 'desc';
      }
      this.setState({
        currentPage: 1,
        sortKey: nextSortKey,
        sortType: nextSortType
      });
      this.props.onPageChange && this.props.onPageChange(1);
      this.props.onSort && this.props.onSort(nextSortKey, nextSortType);
    }
  }, {
    key: 'handleLoad',
    value: function handleLoad(res) {
      var url = this.props.url;

      res = (0, _dataFilter2.default)(this, res);
      (0, _invariant2.default)((0, _isPlainObject2.default)(res), '`DataTable2` data should be `Plain Object`, check the response of `' + url + '` or the return value of `dataFilter`.');
      var _res = res,
          totalCounts = _res.totalCounts;

      var data = res.data || [];
      (0, _invariant2.default)(Array.isArray(data), 'Invalid JSON for `DataTable2`, check the response of `' + url + '` or the return value of `dataFilter`. eg:\n      {\n        totalCounts: 1200,\n        data: [{...}]\n      }');
      this.setState({ totalCounts: totalCounts, data: data });
    }
  }, {
    key: 'handlePageChange',
    value: function handlePageChange(currentPage) {
      this.setState({ currentPage: currentPage });
      this.props.onPageChange && this.props.onPageChange(currentPage);
    }
  }, {
    key: 'getUrl',
    value: function getUrl() {
      var _props = this.props,
          url = _props.url,
          pagingDisabled = _props.pagingDisabled,
          pageSize = _props.pageSize;
      var _state2 = this.state,
          currentPage = _state2.currentPage,
          sortKey = _state2.sortKey,
          sortType = _state2.sortType;

      if (this.props.getUrl) {
        return this.props.getUrl({ currentPage: currentPage, pageSize: pageSize, sortKey: sortKey, sortType: sortType });
      }
      if (!url) return;

      var query = (0, _create2.default)(null);
      pagingDisabled || (0, _assign2.default)(query, {
        start: this.getStart(),
        limit: pageSize
      });
      sortKey && (0, _assign2.default)(query, { sortKey: sortKey, sortType: sortType });

      var queryString = (0, _keys2.default)(query).map(function (key) {
        return key + '=' + query[key];
      }).join('&');
      var _url = url;
      if (queryString) {
        var connector = _url.indexOf('?') === -1 ? '?' : '&';
        _url += connector + queryString;
      }
      return _url;
    }
  }, {
    key: 'getTheads',
    value: function getTheads() {
      var _this2 = this;

      var columns = this.props.columns;
      var _state3 = this.state,
          sortKey = _state3.sortKey,
          sortType = _state3.sortType;

      var Theads = columns.map(function (item, i) {
        var title = item.title,
            sortable = item.sortable;

        var icon = sortable ? 'sort' : null;
        if (sortable && item.key && item.key === sortKey) {
          icon += '-' + sortType;
        }
        return _react2.default.createElement(
          'th',
          {
            key: i,
            width: item.width,
            className: (0, _classnames2.default)({ 'bfd-datatable__th--sortable': sortable }),
            onClick: function onClick() {
              return sortable && _this2.handleSort(item.key);
            }
          },
          title,
          sortable && _react2.default.createElement(_Icon2.default, { className: 'bfd-datatable__sort-symbol', type: icon })
        );
      });
      return Theads;
    }
  }, {
    key: 'getRow',
    value: function getRow(item, i) {
      var _props2 = this.props,
          columns = _props2.columns,
          rowRender = _props2.rowRender;

      if (rowRender) {
        return rowRender(item, i, columns);
      }
      var Tds = columns.map(function (column, j) {
        var value = item[column.key];
        return _react2.default.createElement(
          'td',
          { key: j },
          column.render ? column.render(item, i, value) : value
        );
      });
      return _react2.default.createElement(
        'tr',
        { key: i },
        Tds
      );
    }
  }, {
    key: 'getCurrentPageData',
    value: function getCurrentPageData() {
      var _props3 = this.props,
          pagingDisabled = _props3.pagingDisabled,
          pageSize = _props3.pageSize,
          url = _props3.url;
      var _state4 = this.state,
          totalCounts = _state4.totalCounts,
          data = _state4.data,
          sortKey = _state4.sortKey,
          sortType = _state4.sortType;

      var renderData = data || [];
      if (totalCounts || pagingDisabled) {
        return renderData;
      }
      if (renderData.length) {
        // local paging
        if (sortKey && !url) {
          renderData = renderData.sort(function (a, b) {
            if (a[sortKey] < b[sortKey]) return sortType === 'desc' ? 1 : -1;
            if (a[sortKey] > b[sortKey]) return sortType === 'desc' ? -1 : 1;
            return 0;
          });
        }
        var start = this.getStart();
        return renderData.slice(start, start + pageSize);
      }
      return renderData;
    }
  }, {
    key: 'getStart',
    value: function getStart() {
      return (this.state.currentPage - 1) * this.props.pageSize;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          className = _props4.className,
          columns = _props4.columns,
          url = _props4.url,
          dataFilter = _props4.dataFilter,
          onPageChange = _props4.onPageChange,
          pageSize = _props4.pageSize,
          pagingDisabled = _props4.pagingDisabled,
          sortKey = _props4.sortKey,
          sortType = _props4.sortType,
          onSort = _props4.onSort,
          rowRender = _props4.rowRender,
          noDataContent = _props4.noDataContent,
          other = (0, _objectWithoutProperties3.default)(_props4, ['className', 'columns', 'url', 'dataFilter', 'onPageChange', 'pageSize', 'pagingDisabled', 'sortKey', 'sortType', 'onSort', 'rowRender', 'noDataContent']);
      var _state5 = this.state,
          currentPage = _state5.currentPage,
          totalCounts = _state5.totalCounts,
          data = _state5.data;

      delete other.currentPage;
      delete other.totalCounts;
      delete other.data;

      var currentPageData = this.getCurrentPageData();

      return _react2.default.createElement(
        _Fetch2.default,
        (0, _extends3.default)({
          className: (0, _classnames2.default)('bfd-datatable', className),
          defaultHeight: 70,
          url: this.getUrl(),
          onSuccess: this.handleLoad.bind(this)
        }, other),
        _react2.default.createElement(
          'table',
          { className: 'bfd-table' },
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              this.getTheads()
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            currentPageData.length ? currentPageData.map(this.getRow.bind(this)) : _react2.default.createElement(
              'tr',
              null,
              _react2.default.createElement(
                'td',
                { colSpan: columns.length, className: 'bfd-datatable__empty' },
                noDataContent
              )
            )
          )
        ),
        pagingDisabled || _react2.default.createElement(_Paging2.default, {
          currentPage: currentPage,
          totalPageNum: totalCounts || data.length,
          pageSize: pageSize,
          onPageChange: this.handlePageChange.bind(this)
        })
      );
    }
  }]);
  return DataTable;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

DataTable.defaultProps = {
  pageSize: 10,
  noDataContent: '无数据'
};

DataTable.propTypes = {

  /**
   * 列配置
   * ```js
   * [{
   *   title: '姓名', // 列头显示内容，string/node
   *   key: 'name', // 数据对应的 key，用于排序、非 render 渲染
   *   sortable: true, // 是否开启排序功能
   *   width: '20%', // 列宽，像素／百分比
   *   render: (item, index, value) => item.authorised ? '已授权' : '未授权'
   * }]
   * ```
   */
  columns: _react.PropTypes.array.isRequired,

  /**
   * 数据源，如果未指定 totalCounts，则根据 data.length 自动分页
   * ```js
   * [{
   *   name: '王XX',
   *   authorised: true
   * }]
   * ```
   */
  data: _react.PropTypes.array,

  /**
   * url 数据源，这里的 url 不包括分页、排序等查询条件，组件内部会自动拼接，例如
   * 指定 path/query.do，最终组件内部处理后变成 path/query.do?start=0&limit=10
   * 也可以自定义 URL 规则，参见 `getUrl` 属性
   *
   * url 数据源模式 JSON 格式：
   * ```js
   * {
   *   totalCounts: 1200, // 没有则按上次请求返回的总条数分页或者根据 data.length 自动分页
   *   data: [{...}] // 同 data 属性格式
   * }
   * ```
   * 如果后台格式无法满足，可自定义 dataFilter 过滤
   * url 数据源模式，分页切换、排序都会动态发请求
   */
  url: _react.PropTypes.string,

  /**
   * 如果组件内部拼装的 url 不满足需求，可自定义最终的 url
   * ```js
   * getUrl={condition => 'your url'}
   * ```
   */
  getUrl: _react.PropTypes.func,

  // url 数据源格式过滤器，返回过滤后的数据
  dataFilter: _react.PropTypes.func,

  // 当前页码，默认1，常用于条件改变后重置分页状态。url 数据源模式下请求参数会增加 start，currentPage 变化后会重新请求
  currentPage: _react.PropTypes.number,

  // 切换分页后的回调，参数为当前页码
  onPageChange: _react.PropTypes.func,

  // 每页显示的条数，默认10。url 数据源模式下请求参数会增加 limit ，pageSize 变化后会重新请求
  pageSize: _react.PropTypes.number,

  // 总条数，用于 data 数据源模式下的分页计算，未指定则根据 data.length 自动分页
  totalCounts: _react.PropTypes.number,

  // 是否禁用分页
  pagingDisabled: _react.PropTypes.bool,

  // 当前排序字段。url 数据源模式下请求参数会增加 sortKey，sortKey 变化后会重新请求
  sortKey: _react.PropTypes.string,

  // 当前排序类型，可选值：desc, asc, 默认 desc。url 数据源模式下请求参数会增加 sortType，sortType 变化后会重新请求
  sortType: _react.PropTypes.string,

  // 排序后的回调，参数: sortKey, sortType
  onSort: _react.PropTypes.func,

  // 自定义 tbody 行渲染逻辑，参数(dataItem, index, columns)，返回 <tr>
  rowRender: _react.PropTypes.func,

  // 无数据时显示的内容，默认`无数据`
  noDataContent: _react.PropTypes.string,

  customProp: function customProp(props) {
    if (props.data && props.url) {
      return new Error('You can not use `data` and `url` at the same time.');
    }
    if (!props.data && !props.url) {
      return new Error('You should provide the `data` or `url` one of them.');
    }
    if (props.currentPage && !props.onPageChange) {
      return new Error('You provide a `currentPage` prop without an `onPageChange` handler.');
    }
    if (props.sortKey && !props.onSort) {
      return new Error('You provide a `sortKey` prop without an `onSort` handler.');
    }
  }
};

exports.default = DataTable;