'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dateformat = require('dateformat');

var _dateformat2 = _interopRequireDefault(_dateformat);

var _Calendar = require('../Calendar');

var _Calendar2 = _interopRequireDefault(_Calendar);

var _Dropdown = require('../../Dropdown');

var _ClearableInput = require('../../ClearableInput');

var _ClearableInput2 = _interopRequireDefault(_ClearableInput);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DatePicker = function (_Component) {
  (0, _inherits3.default)(DatePicker, _Component);

  function DatePicker(props) {
    (0, _classCallCheck3.default)(this, DatePicker);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DatePicker.__proto__ || (0, _getPrototypeOf2.default)(DatePicker)).call(this));

    _this.state = {
      date: props.defaultDate || props.date
    };
    return _this;
  }

  (0, _createClass3.default)(DatePicker, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'date' in nextProps && this.setState({ date: nextProps.date });
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(date) {
      this.setState({ date: date });
      this.refs.dropdown.close();
      this.props.onSelect && this.props.onSelect(date);
    }
  }, {
    key: 'handleInput',
    value: function handleInput(date) {
      this.setState({ date: date });
      this.props.onSelect && this.props.onSelect(date);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          defaultDate = _props.defaultDate,
          onSelect = _props.onSelect,
          min = _props.min,
          max = _props.max,
          start = _props.start,
          end = _props.end,
          captionRender = _props.captionRender,
          weekDayNames = _props.weekDayNames,
          placeholder = _props.placeholder,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultDate', 'onSelect', 'min', 'max', 'start', 'end', 'captionRender', 'weekDayNames', 'placeholder']);
      var date = this.state.date;

      delete other.date;

      var calendarProps = { date: date, min: min, max: max, start: start, end: end, captionRender: captionRender, weekDayNames: weekDayNames };

      return _react2.default.createElement(
        _Dropdown.Dropdown,
        (0, _extends3.default)({
          ref: 'dropdown'
        }, other),
        _react2.default.createElement(
          _Dropdown.DropdownToggle,
          { className: (0, _classnames2.default)('bfd-datepicker', className) },
          _react2.default.createElement(_ClearableInput2.default, {
            placeholder: placeholder,
            value: date ? (0, _dateformat2.default)(date, 'yyyy-mm-dd') : null,
            onChange: this.handleInput.bind(this),
            readOnly: true
          })
        ),
        _react2.default.createElement(
          _Dropdown.DropdownMenu,
          { className: 'bfd-datepicker__popover' },
          _react2.default.createElement(_Calendar2.default, (0, _extends3.default)({
            onSelect: this.handleSelect.bind(this)
          }, calendarProps))
        )
      );
    }
  }]);
  return DatePicker;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

DatePicker.defaultProps = {
  placeholder: '请选择日期'
};

DatePicker.propTypes = {

  // 指定日期
  date: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 初始化指定的日期（不可控）
  defaultDate: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 日期选择后的回调，参数为选中的日期时间戳
  onSelect: _react.PropTypes.func,

  // 可选日期范围最小值
  min: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 可选日期范围最大值
  max: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 区间模式，日期区间开始值
  start: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // 区间模式，日期区间结束值
  end: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // placeholder，默认`请选择日期`
  placeholder: _react.PropTypes.string,

  /**
   * 日历标题渲染逻辑，默认
   * ```js
   * function captionRender(state) {
   *   return `${state.currentYear}年 ${state.currentMonth + 1}月`
   * }
   * ```
   */
  captionRender: _react.PropTypes.func,

  // 一周内各天的名称，默认`['一', '二', '三', '四', '五', '六', '日']`
  weekDayNames: _react.PropTypes.array,

  customProp: function customProp(_ref) {
    var date = _ref.date,
        onSelect = _ref.onSelect;

    if (date && !onSelect) {
      return new Error('You provided a `date` prop without an `onSelect` handler');
    }
  }
};

exports.default = DatePicker;