'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Editable = function (_Component) {
  (0, _inherits3.default)(Editable, _Component);

  function Editable(props) {
    (0, _classCallCheck3.default)(this, Editable);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Editable.__proto__ || (0, _getPrototypeOf2.default)(Editable)).call(this));

    var value = 'value' in props ? props.value : props.defaultValue;
    _this.state = {
      value: value,
      changedValue: value || '',
      editing: props.defaultEditing || false
    };
    return _this;
  }

  (0, _createClass3.default)(Editable, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({
        value: nextProps.value,
        changedValue: nextProps.value
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.editing) {
        this.refs.input.select();
      }
    }
  }, {
    key: 'handleEdit',
    value: function handleEdit() {
      var _this2 = this;

      this.setState({
        editing: true
      }, function () {
        _this2.refs.input.select();
      });
    }
  }, {
    key: 'handleInput',
    value: function handleInput(e) {
      e.stopPropagation();
      this.setState({
        changedValue: e.target.value
      });
    }
  }, {
    key: 'handleOk',
    value: function handleOk() {
      var changedValue = this.state.changedValue;
      this.setState({
        editing: false,
        value: changedValue
      });
      this.props.onChange && this.props.onChange(changedValue);
    }
  }, {
    key: 'handleCancel',
    value: function handleCancel() {
      this.setState({
        editing: false,
        changedValue: this.state.value
      });
      this.props.onCancel && this.props.onCancel();
    }
  }, {
    key: 'handleKeyDown',
    value: function handleKeyDown(e) {
      if (e.key === 'Enter') {
        this.handleOk();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          defaultValue = _props.defaultValue,
          onChange = _props.onChange,
          onCancel = _props.onCancel,
          defaultEditing = _props.defaultEditing,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultValue', 'onChange', 'onCancel', 'defaultEditing']);
      var _state = this.state,
          editing = _state.editing,
          value = _state.value,
          changedValue = _state.changedValue;


      delete other.value;

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-editable', className) }, other),
        editing ? _react2.default.createElement(
          'div',
          { className: 'bfd-editable__editing-container' },
          _react2.default.createElement(_Input2.default, {
            ref: 'input',
            value: changedValue,
            onChange: this.handleInput.bind(this),
            onKeyDown: this.handleKeyDown.bind(this)
          }),
          _react2.default.createElement(_Button2.default, { icon: 'check', onClick: this.handleOk.bind(this) }),
          _react2.default.createElement(_Button2.default, { icon: 'close', type: 'minor', onClick: this.handleCancel.bind(this) })
        ) : _react2.default.createElement(
          'div',
          {
            className: 'bfd-editable__normal-container',
            onClick: this.handleEdit.bind(this)
          },
          value
        )
      );
    }
  }]);
  return Editable;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

Editable.propTypes = {

  // 待编辑的值
  value: _react.PropTypes.string,

  // 初始化待编辑的值（不可控）
  defaultValue: _react.PropTypes.string,

  // 确定后的回调，参数为当前值
  onChange: _react.PropTypes.func,

  // 取消后的回调
  onCancel: _react.PropTypes.func,

  // 初始化时是否处于编辑状态（不可控）
  defaultEditing: _react.PropTypes.bool,

  customProp: function customProp(_ref) {
    var value = _ref.value,
        onChange = _ref.onChange;

    if (value && !onChange) {
      return new Error('You provided a `value` prop without an `onChange` handler');
    }
  }
};

exports.default = Editable;