'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = function (_Component) {
  (0, _inherits3.default)(FormItem, _Component);

  function FormItem() {
    (0, _classCallCheck3.default)(this, FormItem);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FormItem.__proto__ || (0, _getPrototypeOf2.default)(FormItem)).call(this));

    _this.state = {
      error: null
    };
    return _this;
  }

  (0, _createClass3.default)(FormItem, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        formItem: this
      };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {
      var value = this.context.form.getItemValue(this);
      if (this.value !== value) {
        this.validate(value);
        this.value = value;
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.context.form.addItem(this);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.context.form.removeItem(this);
    }

    /**
     * @public
     * @name this.refs.formItem.validate
     * @param  {*} value 待验证字段的数据
     * @return {boolean} 成功/失败
     * @description 单个字段验证
     */

  }, {
    key: 'validate',
    value: function validate(value) {
      var rules = this.context.form.props.rules;
      var rule = rules && rules[this.props.name];
      var isValid = true;
      if (rule) {
        var error = rule(value);
        if (error && typeof error === 'string') {
          isValid = false;
        }
        this.setState({ error: error });
      }
      return isValid;
    }
  }, {
    key: 'render',
    value: function render() {
      var error = this.state.error;
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          name = _props.name,
          multiple = _props.multiple,
          required = _props.required,
          help = _props.help,
          label = _props.label,
          other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'name', 'multiple', 'required', 'help', 'label']);


      if (multiple) {
        (0, _invariant2.default)(Array.isArray(this.context.form.state.data[name]), 'The value type of \'FormItem\' which you set \'multiple\' should be \'Array\', check the \'Form data.' + name + '\'.');
      }

      var labelWidth = this.context.form.props.labelWidth;

      var Help = help && _react2.default.createElement(
        'div',
        { className: 'bfd-form__item-tip' },
        _react2.default.createElement(_Icon2.default, { type: 'question-circle' }),
        help
      );

      var Error = error && _react2.default.createElement(
        'div',
        { className: 'bfd-form__item-tip' },
        _react2.default.createElement(_Icon2.default, { type: 'info-circle' }),
        error
      );

      var classNames = (0, _classnames2.default)('bfd-form__item', {
        'bfd-form__item--error': error
      }, className);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: classNames }, other),
        label && _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)('bfd-form__item-label', {
              'bfd-form__item-label--required': required
            }),
            style: { width: labelWidth + 'px' }
          },
          label,
          '\uFF1A'
        ),
        _react2.default.createElement(
          'div',
          { className: 'bfd-form__item-content' },
          children,
          Error || Help
        )
      );
    }
  }]);
  return FormItem;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

FormItem.contextTypes = {
  form: _react.PropTypes.object
};

// For FormInput, FormSelect...
FormItem.childContextTypes = {
  formItem: _react.PropTypes.instanceOf(FormItem)
};

FormItem.propTypes = {

  // label 显示内容
  label: _react.PropTypes.string,

  // 表单数据 key，与 data、rules 对应
  name: _react.PropTypes.string.isRequired,

  // 是否必填，label 显示上的区别
  required: _react.PropTypes.bool,

  // 提示信息
  help: _react.PropTypes.string,

  // 是否多条，用于一个 name 对应多个 FormItem 场景，即 name 属性对应的字段要求数组格式
  multiple: _react.PropTypes.bool
};

exports.default = FormItem;