'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

require('./index.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Chart = require('../Chart');

var _Chart2 = _interopRequireDefault(_Chart);

var _main = require('./main');

var _main2 = _interopRequireDefault(_main);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LineChart = function LineChart(props) {
  var className = props.className,
      other = (0, _objectWithoutProperties3.default)(props, ['className']);

  return _react2.default.createElement(_Chart2.default, (0, _extends3.default)({ type: _main2.default, className: (0, _classnames2.default)('bfd-line-chart', className) }, other));
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */

LineChart.propTypes = {

  // Y 轴字段配置
  cols: _react.PropTypes.object.isRequired,

  // X 轴字段 key
  category: _react.PropTypes.string.isRequired,

  // 线的颜色值，数组的形式按顺序配置
  colors: _react.PropTypes.array,

  /**
   * Y 轴相关配置
   * ```js
   * {
   *   // Y字段值格式，默认 '.2s', 其他格式配置参考 
   *   // https://github.com/d3/d3-format 
   *   format: '.2%'
   * }
   * ```
   */
  yAxis: _react.PropTypes.object,

  /**
   * 数据源，格式：
   * ```js
   * // 字段分别对应 cols 和 category 的配置
   * [{
   *   user: 100,
   *   sales: 3432,
   *   date: "2016-01-01"
   * }]
   * ```
   */
  data: _react.PropTypes.object,

  // URL 数据源，格式同 data
  url: _react.PropTypes.string
};

exports.default = LineChart;