'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  handleLabelRemove: function handleLabelRemove(value) {
    this.removeValue(value);
  },
  handleOptionCheck: function handleOptionCheck(value, e) {
    e.stopPropagation();
    e.target.checked ? this.addValue(value) : this.removeValue(value);
  },
  handleToggleAll: function handleToggleAll(e) {
    e.stopPropagation();
    this.toggleAll(e.target.checked);
  },
  handleLoad: function handleLoad(data) {
    if (this.props.dataFilter) {
      data = this.props.dataFilter(data);
      (0, _invariant2.default)(!!data, '`dataFilter` should return new data, check the `dataFilter` of `Select`.');
    }
    this.setState({ data: data });
  },
  handleDropdownToggle: function handleDropdownToggle(open) {
    if (open) {
      this.refs.tagList.focus();
    } else {
      this.refs.tagList.blur();
    }
  },
  handleInput: function handleInput(value) {
    this.setState({
      searchValue: value,
      index: value ? 0 : -1
    });
  },
  handleKeyDown: function handleKeyDown(e) {
    var key = e.key;
    var options = this.options;
    var index = this.state.index;

    if (key === 'ArrowDown' || key === 'ArrowUp') {
      if (key === 'ArrowDown') {
        if (index === options.length - 1) index = -1;else index++;
      }
      if (key === 'ArrowUp') {
        e.preventDefault();
        if (index === -1) index = options.length - 1;else index--;
      }
      this.setState({ index: index });
    }
    if (key === 'Enter' && index > -2) {
      if (index > -1) {
        var value = options[index].props.value;
        if (this.valueSet.has(value)) {
          this.removeValue(value);
        } else {
          this.addValue(value);
        }
      } else {
        this.toggleAll(!this.isAll);
      }
    }
    if (key === 'Backspace' && !this.state.searchValue) {
      var _value = this.state.values.pop();
      _value && this.removeValue(_value);
    }
  }
}; /**
    * Copyright 2016-present, Baifendian, Inc.
    * All rights reserved.
    *
    * This source code is licensed under the BSD-style license found in the
    * LICENSE file in the root directory of this source tree. An additional grant
    * of patent rights can be found in the PATENTS file in the same directory.
    */