'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Layout = require('../Layout');

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Paging = function (_Component) {
  (0, _inherits3.default)(Paging, _Component);

  function Paging(props) {
    (0, _classCallCheck3.default)(this, Paging);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Paging.__proto__ || (0, _getPrototypeOf2.default)(Paging)).call(this));

    _this.state = {
      currentIndex: props.currentPage,
      showPage: props.maxSeries || 4,
      goPageNum: ''
    };
    return _this;
  }

  (0, _createClass3.default)(Paging, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.currentPage !== nextProps.currentPage) {
        this.setState({
          currentIndex: nextProps.currentPage
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      // 分页逻辑代码
      var pageNum = Math.ceil(this.props.totalPageNum / this.props.pageSize);
      var currentIndex = this.state.currentIndex;
      var _props = this.props,
          currentPage = _props.currentPage,
          totalPageNum = _props.totalPageNum,
          pageSize = _props.pageSize,
          onPageChange = _props.onPageChange,
          maxSeries = _props.maxSeries,
          hideGo = _props.hideGo,
          auxiliaryRender = _props.auxiliaryRender,
          other = (0, _objectWithoutProperties3.default)(_props, ['currentPage', 'totalPageNum', 'pageSize', 'onPageChange', 'maxSeries', 'hideGo', 'auxiliaryRender']);


      return _react2.default.createElement(
        _Layout.Row,
        null,
        _react2.default.createElement(
          'div',
          { className: 'bfd-paging__layout-div bfd-paging__total-name' },
          auxiliaryRender(this.props)
        ),
        _react2.default.createElement(
          'div',
          { className: 'bfd-paging__layout-right' },
          _react2.default.createElement(
            'ul',
            { className: 'bfd-paging__pagination' },
            _react2.default.createElement(
              'li',
              null,
              _react2.default.createElement(
                'a',
                { onClick: this.handleLaquoClick.bind(this), className: 'bfd-paging__pagination-li--prev ' + (currentIndex === 1 ? 'bfd-paging__pagination-li--frist' : '') },
                '<'
              )
            ),
            this.getPages(currentIndex, pageNum),
            _react2.default.createElement(
              'li',
              null,
              _react2.default.createElement(
                'a',
                { onClick: this.handleRaquoClick.bind(this), className: 'bfd-paging__pagination-li--next ' + (currentIndex === pageNum ? 'bfd-paging__pagination-li--end' : '') },
                '>'
              )
            )
          ),
          !this.props.hideGo ? _react2.default.createElement(
            'div',
            { className: 'bfd-paging__go' },
            _react2.default.createElement(_Input2.default, { onChange: this.checkNumber.bind(this), value: this.state.goPageNum, className: 'bfd-paging__go-number' }),
            _react2.default.createElement(
              _Button2.default,
              { onClick: this.handleGoPage.bind(this), className: 'btn btn-primary' },
              'GO'
            )
          ) : ''
        )
      );
    }
  }, {
    key: 'getPages',
    value: function getPages(currentPage, maxPage) {
      var pages = [];
      var showPage = this.state.showPage;

      if (maxPage <= showPage + 2) {
        for (var i = 1; i <= maxPage; i++) {
          var html = this.createPageEl(i);
          pages.push(html);
        }
      } else {
        if (currentPage <= showPage) {
          for (var _i = 1; _i <= showPage + 2 && _i <= maxPage; _i++) {
            var _html = this.createPageEl(_i);
            if (_i < maxPage - 1 && _i == showPage + 1) {
              var dotsHtml = _react2.default.createElement(
                'li',
                { key: 'd' + _i },
                _react2.default.createElement(
                  'span',
                  null,
                  '...'
                )
              );
              pages.push(dotsHtml);
            } else {
              if (_i == showPage + 2) {
                pages.push(this.createPageEl(maxPage, +new Date()));
              } else {
                pages.push(_html);
              }
            }
          }
        } else if (currentPage > showPage && currentPage + showPage <= maxPage - 2) {
          pages[0] = this.createPageEl(1);
          if (currentPage == 3) {
            pages[1] = this.createPageEl(2);
          } else {
            pages[1] = _react2.default.createElement(
              'li',
              { key: "d1" },
              _react2.default.createElement(
                'span',
                null,
                '...'
              )
            );
          }

          var _i2 = currentPage;
          for (; _i2 < currentPage + showPage; _i2++) {
            var _html2 = this.createPageEl(_i2);
            pages.push(_html2);
          }
          pages.push(_react2.default.createElement(
            'li',
            { key: 'd' + _i2 },
            _react2.default.createElement(
              'span',
              null,
              '...'
            )
          ));
          pages.push(this.createPageEl(maxPage));
        } else {
          pages[0] = this.createPageEl(1);
          pages[1] = _react2.default.createElement(
            'li',
            { key: "d1" },
            _react2.default.createElement(
              'span',
              null,
              '...'
            )
          );
          var _i3 = currentPage;
          if (maxPage - currentPage < showPage - 1) {
            _i3 = currentPage - (showPage - 1 - (maxPage - currentPage));
          }
          for (; _i3 <= maxPage; _i3++) {
            var _html3 = this.createPageEl(_i3);
            pages.push(_html3);
          }
        }
      }
      return pages;
    }
  }, {
    key: 'createPageEl',
    value: function createPageEl(num, key) {
      key = key || num;
      var active = 'bfd-paging__pagination-li--active';
      var isActive = this.state.currentIndex == num ? active : '';
      return _react2.default.createElement(
        'li',
        { key: key, className: isActive, onClick: this.handleClick.bind(this, num) },
        _react2.default.createElement(
          'a',
          null,
          num
        )
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick(i) {
      this.setState({
        currentIndex: i
      });
      if (this.props.onPageChange) {
        this.props.onPageChange(i);
      }
      if (this.props.onChange) {
        this.props.onChange('currentPage=' + i + '&pageSize=' + this.props.pageSize, i);
      }
    }
  }, {
    key: 'handleGoPage',
    value: function handleGoPage() {
      var number = parseInt(this.state.goPageNum) || this.state.currentIndex;
      var pageNum = Math.ceil(this.props.totalPageNum / this.props.pageSize);

      if (number <= 0) {
        number = 1;
      } else if (number > pageNum) {
        number = pageNum;
      }

      this.setState({
        currentIndex: number
      });

      number != this.state.currentIndex && this.props.onPageChange && this.props.onPageChange(number);
    }
  }, {
    key: 'checkNumber',
    value: function checkNumber(e) {
      var value = e.target.value;
      var numberReg = /^\+?[1-9][0-9]*$/;
      if (!numberReg.test(value)) {
        this.setState({
          goPageNum: ''
        });
      } else {
        this.setState({
          goPageNum: value
        });
      }
    }
  }, {
    key: 'handleLaquoClick',
    value: function handleLaquoClick() {
      if (this.state.currentIndex > 1) {
        if (this.props.onChange) {
          this.props.onChange('currentPage=' + (this.state.currentIndex - 1) + '&pageSize=' + this.props.pageSize, this.state.currentIndex - 1);
        }
        this.setState({
          currentIndex: this.state.currentIndex - 1
        });
        if (this.props.onPageChange) {
          this.props.onPageChange(parseInt(this.state.currentIndex - 1));
        }
      }
    }
  }, {
    key: 'handleRaquoClick',
    value: function handleRaquoClick() {
      var pageNum = Math.ceil(this.props.totalPageNum / this.props.pageSize);
      if (this.state.currentIndex < pageNum) {
        if (this.props.onChange) {
          this.props.onChange('currentPage=' + (this.state.currentIndex + 1) + '&pageSize=' + this.props.pageSize, this.state.currentIndex + 1);
        }

        this.setState({
          currentIndex: this.state.currentIndex + 1
        });
        if (this.props.onPageChange) {
          this.props.onPageChange(parseInt(this.state.currentIndex + 1));
        }
      }
    }
  }]);
  return Paging;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

Paging.defaultProps = {
  auxiliaryRender: function auxiliaryRender(props) {
    return _react2.default.createElement(
      'div',
      null,
      '\u5171\u6709',
      _react2.default.createElement(
        'span',
        { style: { color: 'red' } },
        props.totalPageNum
      ),
      '\u6761\u8BB0\u5F55'
    );
  }
};

Paging.propTypes = {

  // 当前页面
  currentPage: _react.PropTypes.number.isRequired,

  // 总记录数
  totalPageNum: _react.PropTypes.number.isRequired,

  // 每页显示条数
  pageSize: _react.PropTypes.number,

  // 页码改变事件， 参数返回被选中的页码
  onPageChange: _react.PropTypes.func,

  // 连续页码显示的最大个数，默认为4个
  maxSeries: _react.PropTypes.number,

  // 隐藏页面跳转功能
  hideGo: _react.PropTypes.bool,

  /**
   * 辅助信息渲染逻辑，默认
   * ```js
   * function auxiliaryRender(props) {
   *   return <div>共有<span style={{color: 'red'}}>{props.totalPageNum}</span>条记录</div>
   * }
   * ```
   */
  auxiliaryRender: _react.PropTypes.func
};

exports.default = Paging;