'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popover = require('../Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _controlled = require('../_shared/propValidator/controlled');

var _controlled2 = _interopRequireDefault(_controlled);

var _extend = require('../_shared/propValidator/extend');

var _extend2 = _interopRequireDefault(_extend);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Slider2 = function (_Component) {
  (0, _inherits3.default)(Slider2, _Component);

  function Slider2(props) {
    (0, _classCallCheck3.default)(this, Slider2);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Slider2.__proto__ || (0, _getPrototypeOf2.default)(Slider2)).call(this));

    _this.handleDragging = _this.handleDragging.bind(_this);
    _this.handleDragEnd = _this.handleDragEnd.bind(_this);

    _this.isSliderFromDrag = false;
    _this.isSliderFromClick = false;

    _this.state = {
      value: ('value' in props ? props.value : props.defaultValue) || 0
    };
    return _this;
  }

  (0, _createClass3.default)(Slider2, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.componentDidRender();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'value' in nextProps && this.setState({ value: nextProps.value });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.componentDidRender();
    }
  }, {
    key: 'handleDragStart',
    value: function handleDragStart(e) {
      if (e.button === 0) {
        if (this.props.disabled) {
          return;
        }
        e.preventDefault();
        this.isSliderFromDrag = true;
        this.isSliderFromClick = false;
        e.preventDefault();
        window.addEventListener('mousemove', this.handleDragging);
        window.addEventListener('mouseup', this.handleDragEnd);
      }
    }
  }, {
    key: 'handleDragging',
    value: function handleDragging(e) {
      var value = this.mousePositionDidChange(e);
      if (typeof value === 'number') {
        this.props.onDragging && this.props.onDragging(value);
      }
    }
  }, {
    key: 'handleDragEnd',
    value: function handleDragEnd() {
      this.isSliderFromDrag = false;
      window.removeEventListener('mousemove', this.handleDragging);
      window.removeEventListener('mouseup', this.handleDragEnd);
      this.props.onChange && this.props.onChange(this.state.value);
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      var _this2 = this;

      if (this.props.disabled) {
        return;
      }
      var value = this.mousePositionDidChange(e);
      if (typeof value === 'number') {
        this.props.onChange && this.props.onChange(value);
      }
      this.updatePosition();
      this.popover.open();
      this.isSliderFromClick = true;

      var rootNode = _reactDom2.default.findDOMNode(this);
      var onMouseLeave = function onMouseLeave() {
        _this2.isSliderFromClick = false;
        _this2.popover.close();
        rootNode.removeEventListener('mouseleave', onMouseLeave);
      };
      rootNode.addEventListener('mouseleave', onMouseLeave);
    }
  }, {
    key: 'mousePositionDidChange',
    value: function mousePositionDidChange(e) {
      var offsetLeft = e.pageX - this.pageX;
      if (offsetLeft > this.width) {
        offsetLeft = this.width;
      } else if (offsetLeft < 0) {
        offsetLeft = 0;
      }
      var stepIndex = Math.round(offsetLeft / this.stepWidth);
      if (this.stepIndex !== stepIndex) {
        this.stepIndex = stepIndex;
        var value = this.props.min + this.stepIndex * this.props.step;
        this.setState({ value: value });
        return value;
      }
    }
  }, {
    key: 'componentDidRender',
    value: function componentDidRender() {
      if (!this.isSliderFromDrag && !this.isSliderFromClick) {
        this.prepareContext();
      }
      if (!this.isSliderFromClick) {
        this.updatePosition();
      }
    }
  }, {
    key: 'prepareContext',
    value: function prepareContext() {
      var _props = this.props,
          min = _props.min,
          max = _props.max,
          step = _props.step;

      this.pageX = this.layerNode.getBoundingClientRect().left;
      this.width = this.layerNode.offsetWidth;
      this.stepCount = (max - min) / step;
      this.stepWidth = this.width / this.stepCount;
      this.stepIndex = Math.round((this.state.value - min) / step);
    }
  }, {
    key: 'updatePosition',
    value: function updatePosition() {
      var offsetLeft = this.stepIndex / this.stepCount * 100 + '%';
      this.sliderNode.style.left = offsetLeft;
      this.rangeNode.style.width = offsetLeft;
    }
  }, {
    key: 'shouldPopoverToggle',
    value: function shouldPopoverToggle() {
      return !this.isSliderFromDrag && !this.isSliderFromClick;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          className = _props2.className,
          min = _props2.min,
          max = _props2.max,
          step = _props2.step,
          value = _props2.value,
          defaultValue = _props2.defaultValue,
          formatter = _props2.formatter,
          onDragging = _props2.onDragging,
          onChange = _props2.onChange,
          disabled = _props2.disabled,
          other = (0, _objectWithoutProperties3.default)(_props2, ['className', 'min', 'max', 'step', 'value', 'defaultValue', 'formatter', 'onDragging', 'onChange', 'disabled']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({
          className: (0, _classnames2.default)('bfd-slider2', {
            'bfd-slider2--disabled': disabled
          }, className),
          onClick: this.handleClick.bind(this)
        }, other),
        _react2.default.createElement(
          'div',
          { className: 'bfd-slider2__layer', ref: function ref(node) {
              return _this3.layerNode = node;
            } },
          _react2.default.createElement('div', { className: 'bfd-slider2__range', ref: function ref(node) {
              return _this3.rangeNode = node;
            } }),
          _react2.default.createElement(
            _Popover2.default,
            {
              content: formatter(this.state.value),
              shouldOpen: this.shouldPopoverToggle.bind(this),
              shouldClose: this.shouldPopoverToggle.bind(this),
              ref: function ref(popover) {
                return _this3.popover = popover;
              }
            },
            _react2.default.createElement('div', {
              className: 'bfd-slider2__slider',
              onClick: function onClick(e) {
                return e.stopPropagation();
              },
              onMouseDown: this.handleDragStart.bind(this),
              ref: function ref(node) {
                return _this3.sliderNode = node;
              }
            })
          )
        )
      );
    }
  }]);
  return Slider2;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

Slider2.defaultProps = {
  min: 0,
  max: 100,
  step: 1,
  formatter: function formatter(value) {
    return value;
  }
};

Slider2.propTypes = {

  // 最小值，默认0
  min: _react.PropTypes.number,

  // 最大值，默认100
  max: _react.PropTypes.number,

  // 步长，默认1
  step: (0, _extend2.default)(_react.PropTypes.number, function (props) {
    if (props.step > props.max) return '`step` prop should not be greater than `max` prop.';
  }),

  // 值
  value: (0, _controlled2.default)(_react.PropTypes.number),

  // 同 value，不可控
  defaultValue: _react.PropTypes.number,

  // 提示框内容格式器，默认 `formatter: value => value`
  formatter: _react.PropTypes.func,

  // 拖动过程事件，参数为当前拖动条的值
  onDragging: _react.PropTypes.func,

  // 拖动完成或点击后的回调，参数为当前拖动条的值
  onChange: _react.PropTypes.func,

  // 是否禁用
  disabled: _react.PropTypes.bool
};

exports.default = Slider2;