'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Line = function (_Component) {
  (0, _inherits3.default)(Line, _Component);

  function Line() {
    (0, _classCallCheck3.default)(this, Line);
    return (0, _possibleConstructorReturn3.default)(this, (Line.__proto__ || (0, _getPrototypeOf2.default)(Line)).apply(this, arguments));
  }

  (0, _createClass3.default)(Line, [{
    key: 'render',
    value: function render() {
      var width = this.props.width;
      var height = this.props.height;
      var index = this.props.index;
      var current = this.props.current;
      var max = this.props.max;
      var w = width >= height ? height : width;
      var y = height / 2 - height / 4 - 10;
      var radius = w / 4;

      var leftLineStyle = {
        left: '0px',
        top: Math.floor(y + radius) + 'px',
        width: width / 2 + 'px',
        float: 'left'
      };

      var rightLineStyle = {
        left: width / 2 + radius + 'px',
        top: Math.floor(y + radius) + 'px',
        width: width / 2 + 'px'
      };

      var classNameLeft = 'bfd-steps__box--line_wait';
      var classNameRight = 'bfd-steps__box--line_wait';
      if (index < current) {
        classNameLeft = 'bfd-steps__box--line_finish';
        classNameRight = 'bfd-steps__box--line_finish';
      } else if (index == current) {
        classNameLeft = 'bfd-steps__box--line_finish';
        classNameRight = 'bfd-steps__box--line_wait';
      }

      if (index == 0) {
        classNameLeft = 'bfd-steps__box--line_hide';
      }
      if (index == max - 1) {
        classNameRight = 'bfd-steps__box--line_hide';
      }

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement('div', { style: leftLineStyle, className: (0, _classnames2.default)('bfd-steps__box--line', classNameLeft) }),
        _react2.default.createElement('div', { style: rightLineStyle, className: (0, _classnames2.default)('bfd-steps__box--line', classNameRight) })
      );
    }
  }]);
  return Line;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

var Title = function (_Component2) {
  (0, _inherits3.default)(Title, _Component2);

  function Title() {
    (0, _classCallCheck3.default)(this, Title);
    return (0, _possibleConstructorReturn3.default)(this, (Title.__proto__ || (0, _getPrototypeOf2.default)(Title)).apply(this, arguments));
  }

  (0, _createClass3.default)(Title, [{
    key: 'render',
    value: function render() {
      var title = this.props.title;
      var index = this.props.index;
      var current = this.props.current;
      var height = this.props.height;
      var y = height / 2 - height / 4 - 10;
      var top = y * 2 + 'px';
      var className = 'bfd-steps__box--title_process';
      if (index < current) {
        className = 'bfd-steps__box--title_finish';
      } else if (index > current) {
        className = 'bfd-steps__box--title_wait';
      }
      return _react2.default.createElement(
        'div',
        { style: { top: top }, className: (0, _classnames2.default)('bfd-steps__box--title', className) },
        title
      );
    }
  }]);
  return Title;
}(_react.Component);

var Circle = function (_Component3) {
  (0, _inherits3.default)(Circle, _Component3);

  function Circle() {
    (0, _classCallCheck3.default)(this, Circle);
    return (0, _possibleConstructorReturn3.default)(this, (Circle.__proto__ || (0, _getPrototypeOf2.default)(Circle)).apply(this, arguments));
  }

  (0, _createClass3.default)(Circle, [{
    key: 'render',
    value: function render() {
      var width = this.props.width;
      var height = this.props.height;
      var index = this.props.index;
      var current = this.props.current;
      var icon = this.props.icon;
      var w = width >= height ? height : width;
      var x = width / 2 - w / 4;
      var y = height / 2 - height / 4 - 10;
      var radius = w / 4;
      var fontSize = radius;
      var style = {
        width: w / 2 + 'px',
        height: w / 2 + 'px',
        left: x + 'px',
        top: y + 'px',
        borderRadius: radius + 'px',
        fontSize: fontSize + 'px',
        lineHeight: w / 2 - 2 + 'px'
      };

      var NavIcon = index + 1;
      if (icon) {
        NavIcon = _react2.default.createElement(_Icon2.default, { type: icon });
      }

      var className = 'bfd-steps__box--circle_process';
      if (index < current) {
        className = 'bfd-steps__box--circle_finish';
      } else if (index > current) {
        className = 'bfd-steps__box--circle_wait';
      }

      return _react2.default.createElement(
        'div',
        { style: style, onClick: this.handleClick.bind(this), className: (0, _classnames2.default)('bfd-steps__box--circle', className) },
        NavIcon
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      var index = this.props.index;
      var title = this.props.title;
      this.props.onStep && this.props.onStep(index, title);
    }
  }]);
  return Circle;
}(_react.Component);

var Step = function (_Component4) {
  (0, _inherits3.default)(Step, _Component4);

  function Step() {
    (0, _classCallCheck3.default)(this, Step);
    return (0, _possibleConstructorReturn3.default)(this, (Step.__proto__ || (0, _getPrototypeOf2.default)(Step)).apply(this, arguments));
  }

  (0, _createClass3.default)(Step, [{
    key: 'render',
    value: function render() {
      var style = {
        width: this.props.width + 'px',
        height: this.props.height + 'px'
      };
      var _props = this.props,
          className = _props.className,
          title = _props.title,
          icon = _props.icon,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'title', 'icon']);


      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ style: style, className: 'bfd-steps__box' }, other),
        _react2.default.createElement(Line, this.props),
        _react2.default.createElement(Circle, this.props),
        _react2.default.createElement(Title, this.props)
      );
    }
  }]);
  return Step;
}(_react.Component);

Step.propTypes = {

  // 标题
  title: _react.PropTypes.string,

  // 图标，http://fontawesome.io/icons/
  icon: _react.PropTypes.string
};

exports.default = Step;