'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _findAllByType = require('../../findAllByType');

var _findAllByType2 = _interopRequireDefault(_findAllByType);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Step = require('../Step');

var _Step2 = _interopRequireDefault(_Step);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Steps = function (_Component) {
  (0, _inherits3.default)(Steps, _Component);

  function Steps() {
    (0, _classCallCheck3.default)(this, Steps);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Steps.__proto__ || (0, _getPrototypeOf2.default)(Steps)).call(this));

    _this.state = {
      width: 0,
      height: 0
    };
    return _this;
  }

  (0, _createClass3.default)(Steps, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var rows = [];
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          height = _props.height,
          current = _props.current,
          onStepClick = _props.onStepClick,
          other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'height', 'current', 'onStepClick']);

      var items = (0, _findAllByType2.default)(children, _Step2.default);
      items.map(function (item, index) {
        rows.push(_react2.default.createElement(_Step2.default, {
          key: index,
          index: index,
          current: _this2.props.current || 0,
          icon: item.props.icon,
          max: items.length,
          width: _this2.state.width,
          height: _this2.state.height,
          title: item.props.title || '',
          onStep: _this2.props.onStepClick
        }));
      });

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({
          ref: 'container',
          style: { height: this.props.height + 'px' },
          className: (0, _classnames2.default)('bfd-steps', className) }, other),
        rows
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var container = this.refs.container;
      if (!parseInt(getComputedStyle(container).height, 10)) {
        container.style.height = '100%';
      }

      var width = this.refs.container.clientWidth;
      var height = this.refs.container.clientHeight;
      var children = this.props.children;

      var items = (0, _findAllByType2.default)(children, _Step2.default);
      this.setState({
        width: width / items.length,
        height: height
      });
    }
  }]);
  return Steps;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

Steps.propTypes = {

  // 步骤条高度
  height: _react.PropTypes.number,

  // 指定当前步骤，从 0 开始记数
  current: _react.PropTypes.number.isRequired,

  // 点击事件，参数返回索引值和名称
  onStepClick: _react.PropTypes.func.isRequired
};

exports.default = Steps;