'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Markers = function Markers(options) {
  var _this = this;

  (0, _classCallCheck3.default)(this, Markers);


  (0, _assign2.default)(this, options);

  var group = this.container.selectAll('g').data(this.data).enter().append('g').attr('class', 'marker').attr('transform', function (d) {
    var x = _this.xAxis.getPosition(d[_this.category]);
    var y = _this.yAxis.getPosition(d[_this.key]);
    return 'translate(' + x + ', ' + y + ')';
  });

  group.append('circle').attr('class', 'marker-inner').attr('r', 5).attr('fill', '#fff').attr('stroke', '#fff');

  group.append('circle').attr('class', 'marker-outer').attr('r', 3.5).attr('fill', '#fff').attr('stroke', this.color).attr('stroke-width', 2);
};

exports.default = Markers;