'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _Axis2 = require('./Axis');

var _Axis3 = _interopRequireDefault(_Axis2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var YAxis = function (_Axis) {
  (0, _inherits3.default)(YAxis, _Axis);

  function YAxis(options) {
    (0, _classCallCheck3.default)(this, YAxis);

    var _this = (0, _possibleConstructorReturn3.default)(this, (YAxis.__proto__ || (0, _getPrototypeOf2.default)(YAxis)).call(this, options));

    _this.scale = _d2.default.scale.linear().domain(_this.getDomain()).range([_this.length, 0]);

    var format = _d2.default.format(_this.format || '.2s');
    _this.axis.scale(_this.scale).orient('left').tickValues(_this.getTickValues()).tickFormat(function (d) {
      return format(d);
    }).tickSize(-_this.right, 10);

    _this.container.attr('class', 'axis-y').call(_this.axis);
    return _this;
  }

  (0, _createClass3.default)(YAxis, [{
    key: 'getDomain',
    value: function getDomain() {
      var domain = _d2.default.extent(this.series.reduce(function (current, next) {
        [].push.apply(current, _d2.default.extent(next.data));
        return current;
      }, []));
      if (domain[0] > 0) {
        domain[0] = 0;
      }
      domain[1] *= 1.1;
      return domain;
    }
  }, {
    key: 'getTickValues',
    value: function getTickValues() {
      var max = this.scale.invert(0);
      var values = [];
      var step = max / 5;
      for (var i = 0; i <= 5; i++) {
        values.push(step * i);
      }
      return values;
    }
  }, {
    key: 'setSeries',
    value: function setSeries(series) {
      this.series = series;
      this.scale.domain(this.getDomain());
      this.axis.tickValues(this.getTickValues());
      this.container.transition().duration(500).call(this.axis);
    }
  }]);
  return YAxis;
}(_Axis3.default);

exports.default = YAxis;