'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Row = function Row(props) {
  var data = props.data,
      onChange = props.onChange,
      hidden = props.hidden,
      path = props.path,
      columns = props.columns;

  var hasChildren = data.children && data.children.length;
  var classNames = (0, _classnames2.default)('bfd-table-tree__row', {
    'bfd-table-tree__row--hidden': hidden,
    'bfd-table-tree__row--open': data.open
  });
  return _react2.default.createElement(
    'tr',
    { className: classNames },
    _react2.default.createElement(
      'td',
      null,
      _react2.default.createElement(
        'div',
        {
          className: 'bfd-table-tree__node',
          style: { marginLeft: (path.length - 1) / 2 * 20 + 'px' } },
        _react2.default.createElement(_Button2.default, {
          style: { visibility: hasChildren ? 'visible' : 'hidden' },
          className: 'bfd-table-tree__node-toggle',
          icon: 'caret-right',
          size: 'sm',
          transparent: true,
          onClick: function onClick() {
            return onChange('set', [].concat((0, _toConsumableArray3.default)(path), ['open']), !data.open);
          }
        }),
        _react2.default.createElement(
          'div',
          { className: 'bfd-table-tree__node-content' },
          columns[0].render ? columns[0].render(data, path) : data[columns[0].key]
        )
      )
    ),
    columns.slice(1).map(function (column, i) {
      return _react2.default.createElement(
        'td',
        { key: i },
        column.render ? column.render(data, path) : data[column.key]
      );
    })
  );
};

exports.default = Row;