'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUpdate = require('react-update');

var _reactUpdate2 = _interopRequireDefault(_reactUpdate);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _shouldComponentUpdate = require('../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _Fetch = require('../Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

require('../table.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableTree = function (_Component) {
  (0, _inherits3.default)(TableTree, _Component);

  function TableTree(props) {
    (0, _classCallCheck3.default)(this, TableTree);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TableTree.__proto__ || (0, _getPrototypeOf2.default)(TableTree)).call(this, props));

    _this.update = _reactUpdate2.default.bind(_this);
    _this.state = {
      data: props.defaultData || props.data
    };
    return _this;
  }

  (0, _createClass3.default)(TableTree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      nextProps.data && this.setState({ data: nextProps.data });
    }
  }, {
    key: 'handleRowChange',
    value: function handleRowChange(type, path, value) {
      var nextData = this.update(type, ['data'].concat((0, _toConsumableArray3.default)(path)), value);
      this.props.onChange && this.props.onChange(nextData);
    }
  }, {
    key: 'loopLeaf',
    value: function loopLeaf(data, path, hidden) {
      var _this2 = this;

      if (!data) return;
      data.forEach(function (item, i) {
        var _path = [].concat((0, _toConsumableArray3.default)(path), [i]);
        var row = _react2.default.createElement(_Row2.default, {
          key: _path.join(''),
          data: item,
          hidden: hidden,
          path: _path,
          columns: _this2.props.columns,
          onChange: _this2.handleRowChange.bind(_this2)
        });
        _this2.rows.push(row);
        _this2.loopLeaf(item.children, [].concat((0, _toConsumableArray3.default)(_path), ['children']), hidden || !item.open);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          className = _props.className,
          columns = _props.columns,
          defaultData = _props.defaultData,
          url = _props.url,
          onChange = _props.onChange,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'columns', 'defaultData', 'url', 'onChange']);
      var data = this.state.data;


      delete other.data;

      this.rows = [];
      this.loopLeaf(data, []);
      return _react2.default.createElement(
        _Fetch2.default,
        (0, _extends3.default)({
          className: (0, _classnames2.default)('bfd-table-tree', className),
          url: url,
          defaultHeight: 100,
          onSuccess: function onSuccess(data) {
            return _this3.setState({ data: data });
          }
        }, other),
        _react2.default.createElement(
          'table',
          { className: 'bfd-table' },
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              columns.map(function (item, i) {
                return _react2.default.createElement(
                  'th',
                  { key: i },
                  item.title
                );
              })
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            this.rows
          )
        )
      );
    }
  }]);
  return TableTree;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

TableTree.propTypes = {

  // 字段配置
  columns: _react.PropTypes.array.isRequired,

  // 数据源
  data: _react.PropTypes.array,

  // 初始化数据源（不可控）
  defaultData: _react.PropTypes.array,

  // 数据改变后的回调，参数为改变后的数据
  onChange: _react.PropTypes.func,

  // URL 数据源
  url: _react.PropTypes.string
};

exports.default = TableTree;