'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _classlist = require('classlist');

var _classlist2 = _interopRequireDefault(_classlist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabPanel = function (_Component) {
  (0, _inherits3.default)(TabPanel, _Component);

  function TabPanel() {
    (0, _classCallCheck3.default)(this, TabPanel);
    return (0, _possibleConstructorReturn3.default)(this, (TabPanel.__proto__ || (0, _getPrototypeOf2.default)(TabPanel)).apply(this, arguments));
  }

  (0, _createClass3.default)(TabPanel, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.prepareIsActive(this.props);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.rootNode = _reactDom2.default.findDOMNode(this);
      if (this.active) {
        this.rootNode.style.display = 'block';
        if (!this.context.tabs.isInit) {
          this.rootNode.offsetWidth;
        }
        (0, _classlist2.default)(this.rootNode).add(TabPanel.activeClassName);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      this.prevActive = this.active;
      this.prepareIsActive(nextProps);
      return this.active || this.prevActive !== this.active;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.active) {
        this.rootNode.style.display = 'block';
        this.rootNode.offsetWidth;
        (0, _classlist2.default)(this.rootNode).add(TabPanel.activeClassName);
      } else {
        this.rootNode.style.display = 'none';
        (0, _classlist2.default)(this.rootNode).remove(TabPanel.activeClassName);
      }
    }
  }, {
    key: 'prepareIsActive',
    value: function prepareIsActive(props) {
      var tabs = this.context.tabs;

      if ('activeKey' in props) {
        this.active = props.activeKey === tabs.props.activeKey;
      } else {
        var index = tabs.panelCount++;
        this.active = index === tabs.state.activeIndex;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          activeKey = _props.activeKey,
          other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'activeKey']);
      var tabs = this.context.tabs;


      'activeKey' in tabs.props && (0, _invariant2.default)('activeKey' in this.props, 'You set `activeKey` for `Tabs` but no `activeKey` for `TabPanel`');

      // Should not render and unmount when not acitve
      if (this.active) {
        this.children = children;
      }

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-tabs__panel', className) }, other),
        this.active ? children : this.children
      );
    }
  }]);
  return TabPanel;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

TabPanel.activeClassName = 'bfd-tabs__panel--active';


TabPanel.contextTypes = {
  tabs: _react.PropTypes.object
};

TabPanel.propTypes = {
  // 与 Tabs activeKey 对应
  activeKey: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number])
};

exports.default = TabPanel;