'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Tabs = function (_Component) {
  (0, _inherits3.default)(Tabs, _Component);

  function Tabs(props) {
    (0, _classCallCheck3.default)(this, Tabs);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Tabs.__proto__ || (0, _getPrototypeOf2.default)(Tabs)).call(this));

    _this.state = {
      activeIndex: props.activeIndex || 0
    };
    return _this;
  }

  (0, _createClass3.default)(Tabs, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        tabs: this
      };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'activeIndex' in nextProps && this.setState({ activeIndex: nextProps.activeIndex || 0 });
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate() {
      this.isInit = false;
      this.tabCount = this.panelCount = 0;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.isInit = true;
      this.tabCount = this.panelCount = 0;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          activeIndex = _props.activeIndex,
          activeKey = _props.activeKey,
          onChange = _props.onChange,
          dynamic = _props.dynamic,
          handleClose = _props.handleClose,
          other = (0, _objectWithoutProperties3.default)(_props, ['children', 'className', 'activeIndex', 'activeKey', 'onChange', 'dynamic', 'handleClose']);

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-tabs', {
            'bfd-tabs--dynamic': dynamic
          }, className) }, other),
        children
      );
    }
  }]);
  return Tabs;
}(_react.Component);

Tabs.childContextTypes = {
  tabs: _react.PropTypes.instanceOf(Tabs)
};

Tabs.propTypes = {

  // 指定（索引值）某个 Tab 处于 active 状态
  activeIndex: _react.PropTypes.number,

  // Tabs 默认以索引来管理 active 的状态，但是你也可以给每个 Tab 以及 TabPanel 绑定 "id"，这里用 activeKey 表示，然后管理 Tabs 的 activeKey 状态来控制选项卡的 active 状态
  activeKey: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),

  // Tab 切换后的回调，参数(index, key)
  onChange: _react.PropTypes.func,

  // 是否开启可关闭模式，并切换不同的选项卡样式
  dynamic: _react.PropTypes.bool,

  // Tab 关闭事件处理，参数(index, key)
  handleClose: _react.PropTypes.func,

  customProp: function customProp(props) {
    if (('activeIndex' in props || 'activeKey' in props) && !props.onChange) {
      return new Error('You provided `activeIndex` or `activeKey` prop without an `onChange` handler');
    }
    if ('activeIndex' in props && 'activeKey' in props) {
      return new Error('`activeIndex` and `activeKey` can\'t exist at the same time');
    }
  }
};

exports.default = Tabs;