'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Layout = require('../Layout');

var _SearchBar = require('./SearchBar');

var _SearchBar2 = _interopRequireDefault(_SearchBar);

var _SelectTable = require('./SelectTable');

var _SelectTable2 = _interopRequireDefault(_SelectTable);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SourceTable = _SelectTable2.default; /**
                                          * Copyright 2016-present, Baifendian, Inc.
                                          * All rights reserved.
                                          *
                                          * This source code is licensed under the BSD-style license found in the
                                          * LICENSE file in the root directory of this source tree. An additional grant
                                          * of patent rights can be found in the PATENTS file in the same directory.
                                          */

var TargetTable = _SelectTable2.default;

var TransferPanel = function (_Component) {
  (0, _inherits3.default)(TransferPanel, _Component);

  function TransferPanel(props) {
    (0, _classCallCheck3.default)(this, TransferPanel);
    return (0, _possibleConstructorReturn3.default)(this, (TransferPanel.__proto__ || (0, _getPrototypeOf2.default)(TransferPanel)).call(this, props));
  }

  (0, _createClass3.default)(TransferPanel, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: { marginTop: this.props.height / 2 + 'px' } },
          _react2.default.createElement(_Button2.default, {
            size: 'sm',
            icon: 'angle-double-right',
            onClick: this.handleS2T.bind(this)
          }),
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          _react2.default.createElement(_Button2.default, {
            type: 'minor',
            size: 'sm',
            icon: 'angle-double-left',
            onClick: this.handleT2S.bind(this)
          })
        )
      );
    }
  }, {
    key: 'handleS2T',
    value: function handleS2T() {
      this.props.onTransfer('s2t');
    }
  }, {
    key: 'handleT2S',
    value: function handleT2S() {
      this.props.onTransfer('t2s');
    }
  }]);
  return TransferPanel;
}(_react.Component);

/**
 * Transfer
 */


var Transfer = function (_Component2) {
  (0, _inherits3.default)(Transfer, _Component2);

  function Transfer(props) {
    (0, _classCallCheck3.default)(this, Transfer);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (Transfer.__proto__ || (0, _getPrototypeOf2.default)(Transfer)).call(this, props));

    _this2.sid = [];
    _this2.tid = [];
    _this2.state = {
      filterText: '',
      searchData: props.sdata || []
    };
    return _this2;
  }

  (0, _createClass3.default)(Transfer, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.sdata != this.props.sdata) {
        this.setState({
          sdata: nextProps.sdata,
          searchData: nextProps.sdata
        });
      }
      if (nextProps.tdata != this.props.tdata) {
        this.setState({
          tdata: nextProps.tdata
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          height = _props.height,
          title = _props.title,
          sdata = _props.sdata,
          tdata = _props.tdata,
          onChange = _props.onChange,
          onSearch = _props.onSearch,
          searchPlaceholder = _props.searchPlaceholder,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'height', 'title', 'sdata', 'tdata', 'onChange', 'onSearch', 'searchPlaceholder']);

      delete other.render;
      return _react2.default.createElement(
        _Layout.Row,
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-transfer', className) }, other),
        _react2.default.createElement(
          _Layout.Col,
          { col: 'md-4' },
          _react2.default.createElement(_SearchBar2.default, {
            placeholder: searchPlaceholder,
            onUserInput: this.handleUserInput.bind(this)
          }),
          _react2.default.createElement(SourceTable, {
            onTransfer: this.handleTransfer.bind(this),
            onFoucsItem: this.handleSourceFouceItem.bind(this),
            data: this.state.searchData,
            height: height || 200,
            direct: 's2t',
            render: this.props.render
          })
        ),
        _react2.default.createElement(
          _Layout.Col,
          { col: 'md-2', className: 'bfd-transfer__bfd-pannel' },
          _react2.default.createElement(TransferPanel, {
            onTransfer: this.handleTransfer.bind(this),
            height: height || 200 })
        ),
        _react2.default.createElement(
          _Layout.Col,
          { col: 'md-4' },
          _react2.default.createElement(
            'div',
            { style: { height: '34px', lineHeight: '34px' } },
            _react2.default.createElement(
              'span',
              null,
              title
            )
          ),
          _react2.default.createElement(TargetTable, {
            onTransfer: this.handleTransfer.bind(this),
            onFoucsItem: this.handleTargetFouceItem.bind(this),
            data: tdata,
            height: height || 200,
            direct: 't2s',
            render: this.props.render
          })
        )
      );
    }
  }, {
    key: 'handleUserInput',
    value: function handleUserInput(filterText) {
      var arr = [];
      for (var i = 0, len = this.props.sdata.length; i < len; i++) {
        var item = this.props.sdata[i];
        var label = this.props.render ? this.props.render(item) : item.label;
        if (typeof this.props.onSearch == 'function') {
          if (this.props.onSearch(label, filterText)) {
            arr.push(item);
          }
        } else {
          if (label.indexOf(filterText) != -1) {
            arr.push(item);
          }
        }
      }
      this.setState({
        filterText: filterText,
        searchData: arr
      });
    }
  }, {
    key: 'handleSourceFouceItem',
    value: function handleSourceFouceItem(sid) {
      if (!sid) {
        return;
      }
      if (sid instanceof Array) {
        this.sid = sid;
      } else {
        this.sid = [sid];
      }
    }
  }, {
    key: 'handleTargetFouceItem',
    value: function handleTargetFouceItem(tid) {
      if (!tid) {
        return;
      }
      if (tid instanceof Array) {
        this.tid = tid;
      } else {
        this.tid = [tid];
      }
    }
  }, {
    key: 'handleTransfer',
    value: function handleTransfer(direct) {
      if (direct == 's2t') {
        //  s->t
        if (!this.sid || this.sid.length == 0) {
          return;
        }
        this.transferData(this.sid, this.props.sdata, this.props.tdata, direct);
      }
      if (direct == 't2s') {
        //  t->s
        if (!this.tid || this.tid.length == 0) {
          return;
        }
        this.transferData(this.tid, this.props.tdata, this.props.sdata, direct);
      }
    }
  }, {
    key: 'transferData',
    value: function transferData(ids, source, target, option) {
      var flag = 0;
      if (!ids || ids.length == 0) {
        if ('s2t' == option) {
          this.sid = [];
        }
        if ('t2s' == option) {
          this.tid = [];
        }
        this.handleUserInput(this.state.filterText);
        if (typeof this.props.onChange == 'function') {
          switch (option) {
            case 's2t':
              this.props.onChange(source, target);break;
            case 't2s':
              this.props.onChange(target, source);break;
          }
        }
        return;
      }
      var id = ids[0]; //  取第一个id
      for (var i = source.length - 1; i >= 0; i--) {
        if (id == source[i].id) {
          var item = source.splice(i, 1);
          target.push(item[0]);
          flag = 1;
          break;
        }
      }

      if (flag) {
        ids.shift(); //  删除第一个id
        this.transferData(ids, source, target, option);
      }
    }
  }]);
  return Transfer;
}(_react.Component);

Transfer.defaultProps = {
  title: '已选项',
  searchPlaceholder: '请输入搜索关键词'
};

Transfer.propTypes = {

  // 两个传输框高度，默认200px
  height: _react.PropTypes.number,

  // 右侧传输框上方标题，默认`已选项`
  title: _react.PropTypes.string,

  // 源数据，包含id、label属性
  sdata: _react.PropTypes.array,

  // 目标数据，包含id、label属性
  tdata: _react.PropTypes.array,

  // 传输框值改变后的回调函数。参数为改变后的值, 第一个参数：sdata, 第二个参数：tdata
  onChange: _react.PropTypes.func,

  // 搜索框关键词与列表数据匹配规则函数, 第一个参数为列表项数据, 第二个参数为搜索关键词
  onSearch: _react.PropTypes.func,

  // 每行数据渲染函数
  render: _react.PropTypes.func,

  // 搜索框 placeholder，默认`请输入搜索关键词`
  searchPlaceholder: _react.PropTypes.string
};

exports.default = Transfer;