'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUpdate = require('react-update');

var _reactUpdate2 = _interopRequireDefault(_reactUpdate);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _shouldComponentUpdate = require('../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _nodeCheckProcessor = require('./nodeCheckProcessor');

var _nodeCheckProcessor2 = _interopRequireDefault(_nodeCheckProcessor);

var _getPathData = require('./getPathData');

var _getPathData2 = _interopRequireDefault(_getPathData);

var _Checkbox = require('../Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _TreeNode = require('./TreeNode');

var _TreeNode2 = _interopRequireDefault(_TreeNode);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Tree = function (_Component) {
  (0, _inherits3.default)(Tree, _Component);

  function Tree(props) {
    (0, _classCallCheck3.default)(this, Tree);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Tree.__proto__ || (0, _getPrototypeOf2.default)(Tree)).call(this, props));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.state = {
      data: props.data || props.defaultData || []
    };
    return _this;
  }

  (0, _createClass3.default)(Tree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      nextProps.data && this.setState({ data: nextProps.data });
    }
  }, {
    key: 'updateDataBySingleProp',
    value: function updateDataBySingleProp(key, value, path) {
      var newData = (0, _reactUpdate2.default)(this.state.data, 'set', [].concat((0, _toConsumableArray3.default)(path), [key]), value);
      this.updateData(newData);
      return newData;
    }
  }, {
    key: 'updateData',
    value: function updateData(newData) {
      this.setState({ data: newData });
      this.props.onChange && this.props.onChange(newData);
    }
  }, {
    key: 'handleActive',
    value: function handleActive(path) {
      this.activePath = path;
    }
  }, {
    key: 'handleNodeSelect',
    value: function handleNodeSelect(path) {
      var newData = this.state.data;
      if (this.activePath && (0, _get2.default)(this.state.data, this.activePath)) {
        newData = (0, _reactUpdate2.default)(newData, 'set', [].concat((0, _toConsumableArray3.default)(this.activePath), ['active']), false);
      }
      newData = (0, _reactUpdate2.default)(newData, 'set', [].concat((0, _toConsumableArray3.default)(path), ['active']), true);
      var pathData = (0, _getPathData2.default)(path, newData);
      this.props.onActive && this.props.onActive(pathData);
      this.props.onSelect && this.props.onSelect(pathData.slice(-1)[0], pathData);
      this.updateData(newData);
    }
  }, {
    key: 'handleNodeCheck',
    value: function handleNodeCheck(checked, item, path) {
      var _this2 = this;

      (0, _nodeCheckProcessor2.default)(this.state.data, checked, item, path, function (newData, newItem) {
        if (_this2.props.onCheck) {
          _this2.props.onCheck(checked, newItem, (0, _getPathData2.default)(path, newData));
        }
        _this2.updateData(newData);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          className = _props.className,
          defaultData = _props.defaultData,
          onChange = _props.onChange,
          checkable = _props.checkable,
          onCheck = _props.onCheck,
          shouldNodeCheckable = _props.shouldNodeCheckable,
          getIcon = _props.getIcon,
          getUrl = _props.getUrl,
          dataFilter = _props.dataFilter,
          noChildrenContent = _props.noChildrenContent,
          shouldNodeSelectable = _props.shouldNodeSelectable,
          onNodeSelect = _props.onNodeSelect,
          onNodeChange = _props.onNodeChange,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'defaultData', 'onChange', 'checkable', 'onCheck', 'shouldNodeCheckable', 'getIcon', 'getUrl', 'dataFilter', 'noChildrenContent', 'shouldNodeSelectable', 'onNodeSelect', 'onNodeChange']);
      var data = this.state.data;

      delete other.data;
      delete other.render;
      delete other.beforeNodeRender;

      var beforeNodeRender = this.props.beforeNodeRender;

      if (checkable) {
        beforeNodeRender = function beforeNodeRender(item, path) {
          var enabled = shouldNodeCheckable ? shouldNodeCheckable(item, path) : true;
          return _react2.default.createElement(_Checkbox2.default, {
            className: 'bfd-tree__checkbox',
            checked: item.checked,
            indeterminate: item.indeterminate,
            disabled: !enabled,
            onChange: enabled ? function (e) {
              return _this3.handleNodeCheck(e.target.checked, item, path);
            } : function () {}
          });
        };
      }

      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-tree', className) }, other),
        _react2.default.createElement(
          'ul',
          null,
          data.map(function (item, i) {
            return _react2.default.createElement(_TreeNode2.default, {
              key: i,
              treeData: data,
              data: item,
              path: [i],
              contentRender: _this3.props.render,
              onActive: _this3.handleActive.bind(_this3),
              onSelect: _this3.handleNodeSelect.bind(_this3),
              onSinglePropChange: _this3.updateDataBySingleProp.bind(_this3),
              beforeRender: beforeNodeRender,
              shouldSelectable: shouldNodeSelectable,
              getIcon: getIcon,
              getUrl: getUrl,
              dataFilter: dataFilter,
              noDataContent: noChildrenContent
            });
          })
        )
      );
    }
  }]);
  return Tree;
}(_react.Component);

Tree.defaultProps = {
  noChildrenContent: '无数据'
};

Tree.propTypes = {

  /**
   * 数据源，与 defaultData、url 方式格式通用
   * 格式说明
   * ```js
   * [{
   *   name: '数据工厂', // 节点显示，默认渲染 name 值，可自定义 render 渲染
   *   open: true, // 是否展开
   *   checked: true, // 是否勾选，用于可勾选模式下
   *   indeterminate: true, // 是否半勾选
   *   active: true, // 是否选中
   *   isParent: true, // 动态加载标识，当前节点展开后会动态加载数据，配合 getUrl 使用
   *   children: [{
   *     name: 'kafka'
   *   }, {
   *     name: 'HBase'
   *   }]
   * }, {
   *   name: '配置中心'
   * }]
   * ```
   */
  data: _react.PropTypes.array,

  // 初始化时数据源（不可控）
  defaultData: _react.PropTypes.array,

  // 数据改变后的回调，如展开／收起、选中、勾选等操作。参数为整个数据源
  onChange: _react.PropTypes.func,

  // 节点渲染回调，参数(item, path)，默认渲染 data.name
  render: _react.PropTypes.func,

  // 设置图标，参数为当前节点数据，可动态判断
  getIcon: _react.PropTypes.func,

  // 按需动态加载数据源 URL，当 isParent 为 true 时，执行请求。参数为当前节点数据以及节点路径下的数据集合
  getUrl: _react.PropTypes.func,

  // 点中一个节点后的回调，参数为节点路径下数据集合，建议使用 onSelect 代替，注意两者的回调参数不同
  onActive: _react.PropTypes.func,

  // 节点选中后的回调，参数为 (data, pathData)
  onSelect: _react.PropTypes.func,

  // 是否可勾选
  checkable: _react.PropTypes.bool,

  // 勾选后的回调，参数为 (checked, data, pathData)
  onCheck: _react.PropTypes.func,

  // 过滤 getUrl 方式返回的数据，处理后请将数据返回
  dataFilter: _react.PropTypes.func,

  // 节点是否可选中的回调判断，参数(item, path)，返回 false 则节点不可选中
  shouldNodeSelectable: _react.PropTypes.func,

  // 节点是否可勾选的回调判断，参数(item, path)，返回 false 则节点不可勾选
  shouldNodeCheckable: _react.PropTypes.func,

  // getUrl 方式无数据时显示内容，默认`无数据`
  noChildrenContent: _react.PropTypes.string,

  customProp: function customProp(props) {
    if (props.data && !props.onChange) {
      return new Error('You provided a `data` prop without an `onChange` handler');
    }
    if (props.onCheck && !props.checkable) {
      return new Error('You provided a `onCheck` prop without a `checkable` prop');
    }
  }
};

exports.default = Tree;