'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _reactUpdate = require('react-update');

var _reactUpdate2 = _interopRequireDefault(_reactUpdate);

var _shouldComponentUpdate = require('../shouldComponentUpdate');

var _shouldComponentUpdate2 = _interopRequireDefault(_shouldComponentUpdate);

var _SelectDropdown = require('../SelectDropdown');

var _SelectDropdown2 = _interopRequireDefault(_SelectDropdown);

var _Tree = require('../Tree');

var _Tree2 = _interopRequireDefault(_Tree);

var _TextOverflow = require('../TextOverflow');

var _TextOverflow2 = _interopRequireDefault(_TextOverflow);

var _TagList = require('../TagList');

var _TagList2 = _interopRequireDefault(_TagList);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var TreeSelect = function (_Component) {
  (0, _inherits3.default)(TreeSelect, _Component);

  function TreeSelect(props) {
    (0, _classCallCheck3.default)(this, TreeSelect);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TreeSelect.__proto__ || (0, _getPrototypeOf2.default)(TreeSelect)).call(this));

    _this.shouldComponentUpdate = _shouldComponentUpdate2.default;

    _this.state = {
      value: props.value || props.defaultValue,
      data: props.data || props.defaultData
    };
    return _this;
  }

  (0, _createClass3.default)(TreeSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var state = {};
      'value' in nextProps && (state.value = nextProps.value);
      'data' in nextProps && (state.data = nextProps.data);
      this.setState(state);
    }
  }, {
    key: 'handleLoad',
    value: function handleLoad(data) {
      if (this.props.dataFilter) {
        data = this.props.dataFilter(data);
      }
      this.setState({ data: data });
    }
  }, {
    key: 'parseData',
    value: function parseData(list) {
      var _this2 = this;

      var newData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : list;
      var path = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
      var value = this.state.value;
      var _props = this.props,
          render = _props.render,
          multiple = _props.multiple;

      list && list.forEach(function (item, i) {

        (0, _invariant2.default)(item.value || item.value === 0, '`TreeSelect` data item should have a `value` property which type should be `String`.');

        var _path = [].concat((0, _toConsumableArray3.default)(path), [i]);
        var title = !render ? item.name : render(item);
        if (multiple) {
          var checked = _this2.valueSet.has(item.value);
          checked && _this2.labels.push({
            value: item.value,
            label: title
          });
          if (!!item.checked !== checked) {
            newData = (0, _reactUpdate2.default)(newData, 'set', [].concat((0, _toConsumableArray3.default)(_path), ['checked']), checked);
          }
        } else {
          var active = item.value === value;
          active && (_this2.title = title);
          if (!!item.active !== active) {
            newData = (0, _reactUpdate2.default)(newData, 'set', [].concat((0, _toConsumableArray3.default)(_path), ['active']), active);
          }
        }
        newData = _this2.parseData(item.children, newData, [].concat((0, _toConsumableArray3.default)(_path), ['children']));
      });
      return newData;
    }
  }, {
    key: 'addValue',
    value: function addValue(value) {
      this.valueSet.add(value);
      this.change([].concat((0, _toConsumableArray3.default)(this.valueSet)));
    }
  }, {
    key: 'removeValue',
    value: function removeValue(value) {
      this.valueSet.delete(value);
      this.change([].concat((0, _toConsumableArray3.default)(this.valueSet)));
    }
  }, {
    key: 'handleCheck',
    value: function handleCheck(checked, item) {
      this[checked ? 'addValue' : 'removeValue'](item.value);
    }
  }, {
    key: 'handleSelect',
    value: function handleSelect(item) {
      this.refs.dropdown.close();
      this.change(item.value);
    }
  }, {
    key: 'change',
    value: function change(value) {
      this.setState({ value: value });
      this.props.onChange && this.props.onChange(value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          className = _props2.className,
          placeholder = _props2.placeholder,
          defaultValue = _props2.defaultValue,
          onChange = _props2.onChange,
          defaultData = _props2.defaultData,
          onDataChange = _props2.onDataChange,
          multiple = _props2.multiple,
          shouldNodeSelectable = _props2.shouldNodeSelectable,
          shouldNodeCheckable = _props2.shouldNodeCheckable,
          getIcon = _props2.getIcon,
          getUrl = _props2.getUrl,
          dataFilter = _props2.dataFilter,
          other = (0, _objectWithoutProperties3.default)(_props2, ['className', 'placeholder', 'defaultValue', 'onChange', 'defaultData', 'onDataChange', 'multiple', 'shouldNodeSelectable', 'shouldNodeCheckable', 'getIcon', 'getUrl', 'dataFilter']);
      var _state = this.state,
          value = _state.value,
          data = _state.data;


      var treeRender = other.render;

      delete other.value;
      delete other.data;
      delete other.render;

      if (multiple) {
        this.labels = [];
        this.valueSet = new _set2.default(value);
      }

      this.title = null;

      var treeProps = {
        shouldNodeSelectable: shouldNodeSelectable,
        shouldNodeCheckable: shouldNodeCheckable,
        getIcon: getIcon,
        getUrl: getUrl,
        data: this.parseData(data),
        render: treeRender,
        onChange: function onChange(data) {
          _this3.setState({ data: data });
          onDataChange && onDataChange(data);
        }
      };

      if (multiple) {
        treeProps.checkable = true;
        treeProps.onCheck = this.handleCheck.bind(this);
      } else {
        treeProps.onSelect = this.handleSelect.bind(this);
      }
      var Title = !multiple ? _react2.default.createElement(
        _TextOverflow2.default,
        null,
        _react2.default.createElement(
          'div',
          { className: 'bfd-tree-select__title' },
          this.title || !value && placeholder
        )
      ) : _react2.default.createElement(_TagList2.default, {
        labels: this.labels,
        placeholder: value && value.length ? '' : placeholder,
        onRemove: this.removeValue.bind(this)
      });

      return _react2.default.createElement(
        _SelectDropdown2.default,
        (0, _extends3.default)({
          ref: 'dropdown',
          className: (0, _classnames2.default)('bfd-tree-select', {
            'bfd-tree-select--multiple': multiple
          }, className),
          title: Title,
          onLoad: this.handleLoad.bind(this),
          hasPropValue: 'value' in this.props || 'defaultValue' in this.props,
          caret: !multiple
        }, other),
        _react2.default.createElement(_Tree2.default, treeProps)
      );
    }
  }]);
  return TreeSelect;
}(_react.Component);

TreeSelect.defaultProps = {
  placeholder: '请选择'
};

TreeSelect.propTypes = {

  // 值，单选为字符串，多选为数组，与数据源 value 字段对应
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.array, _react.PropTypes.number]),

  // 初始化值（不可控）
  defaultValue: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.array]),

  // 切换选择后的回调，回调参数为选中的节点（多选模式为数组）
  onChange: _react.PropTypes.func,

  // 树结构数据源，与 Tree 组件不同的是需要 value 字段一一对应
  data: _react.PropTypes.array,

  // 树结构数据源（不可控）
  defaultData: _react.PropTypes.array,

  // 树结构 URL 数据源
  url: _react.PropTypes.string,

  // url 数据源过滤器
  dataFilter: _react.PropTypes.func,

  // 树结构数据源改变后的回调
  onDataChange: _react.PropTypes.func,

  // 无匹配时显示内容，默认｀请选择｀
  placeholder: _react.PropTypes.string,

  // 同 Tree render
  render: _react.PropTypes.func,

  // 是否多选，开启此属性后才会出现复选框，多选模式 value 要求数组格式
  multiple: _react.PropTypes.bool,

  // 节点是否可选中的回调判断，参数(item, path)，返回 false 则节点不可选中
  shouldNodeSelectable: _react.PropTypes.func,

  // 节点是否可勾选的回调判断，参数(item, path)，返回 false 则节点不可勾选
  shouldNodeCheckable: _react.PropTypes.func,

  // 同 Tree getIcon
  getIcon: _react.PropTypes.func,

  // 同 Tree getUrl
  getUrl: _react.PropTypes.func,

  // 是否禁用
  disabled: _react.PropTypes.bool,

  // 最小宽度，默认 160，multiple 模式下无效
  minWidth: _react.PropTypes.number,

  customProp: function customProp(props) {
    if ('value' in props && !props.onChange) {
      return new Error('You provided a `value` prop without an `onClick` handler');
    }
    if ('data' in props && !props.onDataChange) {
      return new Error('You provided a `data` prop without an `onDataChange` handler');
    }
    if (props.multiple && !Array.isArray(props.value || props.defaultValue)) {
      return new Error('You provided a `multiple` prop without an array `value`');
    }
    if (!props.multiple && Array.isArray(props.value || props.defaultValue)) {
      return new Error('You provided an array `value` prop without a `multiple` prop');
    }
  }
};

exports.default = TreeSelect;