'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _xhr = require('../xhr');

var _xhr2 = _interopRequireDefault(_xhr);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _FileList = require('./FileList');

var _FileList2 = _interopRequireDefault(_FileList);

require('./main.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2016-present, Baifendian, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var Upload = function (_Component) {
  (0, _inherits3.default)(Upload, _Component);

  function Upload() {
    (0, _classCallCheck3.default)(this, Upload);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Upload.__proto__ || (0, _getPrototypeOf2.default)(Upload)).call(this));

    _this.state = {
      list: []
    };
    return _this;
  }

  (0, _createClass3.default)(Upload, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          action = _props.action,
          fileName = _props.fileName,
          text = _props.text,
          multiple = _props.multiple,
          onUplading = _props.onUplading,
          onComplete = _props.onComplete,
          showFileList = _props.showFileList,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'action', 'fileName', 'text', 'multiple', 'onUplading', 'onComplete', 'showFileList']);

      var isShowList = typeof showFileList == 'undefined' ? true : showFileList;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ className: (0, _classnames2.default)('bfd-upload', className) }, other),
        _react2.default.createElement('input', { ref: 'file', onChange: this.handleChange.bind(this), type: 'file', multiple: multiple ? true : false, style: { display: 'none' } }),
        _react2.default.createElement(
          _Button2.default,
          { onClick: this.handleClick.bind(this) },
          text
        ),
        isShowList ? _react2.default.createElement(
          'div',
          { className: 'bfd-upload__listbox' },
          _react2.default.createElement(_FileList2.default, { data: this.state.list, onRemove: this.handleRemove.bind(this) })
        ) : ''
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      var fileEl = this.refs.file;
      fileEl.value = '';
      fileEl.click();
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var el = event.target;
      var files = el.files;
      var onUplading = this.props.onUplading;
      var onUpload = this.props.onUpload;
      onUplading && onUplading(0);
      onUpload ? onUpload(files) : this.upload(files);
      el.value = '';
    }
  }, {
    key: 'upload',
    value: function upload(files) {
      var onUplading = this.props.onUplading;
      var self = this;
      var arr = [];
      for (var i = 0; i < files.length; i++) {
        var file = files[i];
        arr.push({
          name: file.name,
          size: file.size,
          type: file.type,
          state: 0
        });(function (self, file, index) {
          var fd = new FormData();
          fd.append(self.props.fileName || 'files', file);
          (0, _xhr2.default)({
            type: 'post',
            url: self.props.action,
            data: fd,
            beforeSend: function beforeSend(xhr) {
              // 侦查当前附件上传情况
              xhr.upload.onprogress = function (evt) {
                var loaded = evt.loaded;
                var tot = evt.total;
                var per = Math.floor(100 * loaded / tot); // 已经上传的百分比
                var list = self.state.list.slice(0);
                var f = list[index];
                f.percent = per;
                onUplading && onUplading(per);
                self.setState({
                  list: list
                });
              };
            },
            success: function success(data) {
              var list = self.state.list.slice(0);
              var f = list[index];
              f.state = 1;
              self.setState({
                list: list
              });
              if (typeof self.props.onComplete == 'function') {
                self.props.onComplete(data, list);
              }
            },
            error: function error(msg) {
              var list = self.state.list.slice(0);
              var f = list[index];
              f.state = 2;
              self.setState({
                list: list
              });
              if (typeof self.props.onComplete == 'function') {
                self.props.onComplete(msg, list);
              }
            },
            complete: function complete() {}
          });
        })(self, file, i);
      }

      this.setState({
        list: arr
      });
    }
  }, {
    key: 'handleRemove',
    value: function handleRemove(currItem) {
      var self = this;
      var arr = this.state.list.slice(0);
      arr.map(function (item, index) {
        if (item == currItem) {
          arr.splice(index, 1);
          self.setState({
            list: arr
          });
          return;
        }
      });
    }
  }]);
  return Upload;
}(_react.Component);

Upload.defaultProps = {
  text: '文件上传'
};

Upload.propTypes = {

  // 上传的地址
  action: _react.PropTypes.string.isRequired,

  // 上传按钮文本内容，默认为`文件上传`
  text: _react.PropTypes.string,

  // 上传文件名称，默认为files
  fileName: _react.PropTypes.string,

  // 是否支持多选文件，ie10+ 支持。开启后按住 ctrl 可选择多个文件。
  multiple: _react.PropTypes.bool,

  // 文件上传进行中事件
  onUplading: _react.PropTypes.func,
  // 上传文件完成时的回调函数
  onComplete: _react.PropTypes.func,

  // 是否显示文件上传列表
  showFileList: _react.PropTypes.bool
};

exports.default = Upload;