'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('./index.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _ToggleNode = require('../_shared/ToggleNode');

var _ToggleNode2 = _interopRequireDefault(_ToggleNode);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Message = function (_Component) {
  (0, _inherits3.default)(Message, _Component);

  function Message(props) {
    (0, _classCallCheck3.default)(this, Message);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Message.__proto__ || (0, _getPrototypeOf2.default)(Message)).call(this));

    _this.state = {
      open: props.open
    };
    _this.prepareClose(props);
    return _this;
  }

  (0, _createClass3.default)(Message, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.toggleNode = new _ToggleNode2.default(_reactDom2.default.findDOMNode(this), 'bfd-message--open');
      this.toggleNode.onClose = function () {
        _this2.props.onClose && _this2.props.onClose();
      };
      this.toggleNode.open();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      'open' in nextProps && this.setState({ open: nextProps.open });
      this.prepareClose(nextProps);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.toggleNode[this.state.open ? 'open' : 'close']();
    }
  }, {
    key: 'prepareClose',
    value: function prepareClose(props) {
      var duration = props.duration;

      duration && setTimeout(this.handleClose.bind(this), duration * 1000);
    }
  }, {
    key: 'handleClose',
    value: function handleClose() {
      this.setState({ open: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          message = _props.message,
          duration = _props.duration;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)('bfd-message', (0, _defineProperty3.default)({}, 'bfd-message--' + type, type)) },
        _react2.default.createElement(_Icon2.default, {
          className: 'bfd-message__symbol',
          type: type === 'success' ? 'check' : 'warning'
        }),
        message,
        duration === 0 && _react2.default.createElement(_Button2.default, {
          className: 'bfd-message__remove',
          transparent: true,
          icon: 'remove',
          onClick: this.handleClose.bind(this)
        })
      );
    }
  }]);
  return Message;
}(_react.Component); /**
                      * Copyright 2016-present, Baifendian, Inc.
                      * All rights reserved.
                      *
                      * This source code is licensed under the BSD-style license found in the
                      * LICENSE file in the root directory of this source tree. An additional grant
                      * of patent rights can be found in the PATENTS file in the same directory.
                      */

Message.propTypes = {
  type: _react.PropTypes.oneOf(['success', 'danger']).isRequired,
  message: _react.PropTypes.node.isRequired,
  duration: _react.PropTypes.number,
  onClose: _react.PropTypes.func,
  open: _react.PropTypes.bool
};

var _render = function render(props) {
  var container = document.createElement('div');
  document.body.appendChild(container);

  var isOpen = false;
  var messageQueue = [];
  var handleClose = function handleClose() {
    isOpen = false;
    var head = messageQueue[0] && messageQueue.shift();
    head && _render(head);
  };

  _render = function render(nextProps) {
    props = (0, _assign2.default)({}, props, nextProps);
    if (isOpen && props.open) {
      return messageQueue.push(props);
    }
    isOpen = props.open;
    _reactDom2.default.render(_react2.default.createElement(Message, (0, _extends3.default)({}, props, { onClose: handleClose })), container);
    props.open || handleClose();
  };
  _render();
};

var message = {

  /**
   * @public
   * @name message.success
   * @param  {string | element} message message 内容，支持 React 元素
   * @param  {number} [duration] 持续时间，单位秒，为0时手动关闭
   * @description 成功信息，默认 2 秒后自动关闭
   */
  success: function success(message) {
    var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;

    _render({
      message: message,
      duration: duration,
      type: 'success',
      open: true
    });
  },


  /**
   * @public
   * @name message.danger
   * @param  {string | element} message message 内容，支持 React 元素
   * @param  {number} [duration] 持续时间，单位秒，为0时手动关闭
   * @description 失败信息，默认 3 秒后自动关闭
   */
  danger: function danger(message) {
    var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3;

    _render({
      message: message,
      duration: duration,
      type: 'danger',
      open: true
    });
  },


  /**
   * @public
   * @name message.close
   * @description 关闭当前 message
   */
  close: function close() {
    _render({ open: false });
  }
};

exports.default = message;